Версия 2023.1
---------------
  [Engine]
+ добавлено свойство Report.IsPrepared
+ добавлен способ отображения текста TextRenderType.Inline
+ реализован конвертор шаблонов JasperReports
+ реализовано подключение к хранимым процедурам в MsSQL
* получение JSON в источнике данных вынесено в интерфейсную часть
- исправлена ошибка, приводившая к System.ArgumentException, когда свойство TextObject.FontWidthRatio равно нулю
- исправлена подсветка текста в RTF парсере
- исправлена ошибка многократных запросов на получение картинки при использовании URL в ImageLocation
- исправлена ошибка в функции IsNull
- исправлена ошибка отрисовки RichObject с выровненными изображениями
- исправлена ошибка, из-за которой неверно производился расчёт вертикальных расстояний при конвертации RichObject в текст
- исправлена ошибка в объекте AdvMatrix при обновлении отчета
- исправлена ошибка с получением строки JSON из JsonTableDataSource
- исправлена ошибка, приводящая к бесконечному циклу при построении таблицы, если на странице недостаточно места для одной строки

  [Designer]
+ добавлена возможность создания вычисляемого столбца для IEnumerable источников данных
+ добавлено окно с сообщением о загрузке отчета при открытии файла
+ добавлен столбец с номерами ошибок в таблице проверки отчета
+ добавлена возможность скрывать и показывать столбцы с номером и типом ошибки в таблице проверки отчета
+ добавлено окно, уведомляющее о попытке сохранить отчет, который уже был изменен
+ добавлена возможность показывать веб-превью отчета, открытого из МоиОтчеты Облако
+ добавлена возможность взаимодействия с источниками данных в Облаке - скачивание, загрузка, обновление
* увеличена скорость работы валидатора отчетов
* кнопка удаления бэнда теперь отключена в ситуациях, когда бэнд удалить нельзя
* изменено название корневой папки в форме МоиОтчеты Облако, теперь зависит от выбранной локализации
* теперь в мастере запроса нельзя создать таблицу, если уже есть другая таблица с таким же именем
- исправлено представление дерева данных с источником данных IEnumerable, столбец которого не добавлялся, если он состоит из значимого типа
- исправлена ошибка с локализацией кнопки "Удалить" в свойствах отчета на вкладке "Скрипт"
- исправлена ошибка с выделением объекта после щелчка по строке в окне валидации отчета
- исправлена ошибка, из-за которой не менялся выбранный объект при изменении высоты бэнда мышью
- исправлена проблема с исключением System.OverflowException при редактировании текстового объекта без редактора
- исправлена ошибка, вызывающая исключение System.StackOverflowException при копировании форматирования
- исправлено выделение объекта, расположенного на неактивной странице, при нажатии на строку в окне "Проверка"
- исправлено отображение прогресса обновления списка ошибок в окне "Валидация" при изменении отчета
- исправлена ошибка с недопустимым значением при изменении цвета линии в редакторе MSChartObject
- исправлен порядок переключения клавишей "Tab" в формах подключений
- исправлена ошибка при которой не сохранялись свойства границ осей диаграммы, при их изменении в редакторе
- исправлены некорректные значения при изменении интервала в полосах на осях в MSChartObject
- исправлена ошибка, возникающая при удалении бэнда через конфигуратор бэндов, если выбран классический режим отображения бэндов
- исправлена ошибка, возникающая при нажатии кнопки "Удалить" на форме настройки бэндов, если в отчете отсутствуют бэнды
- исправлена ошибка, возникающая при удалении бэндов с рабочей области при удержании левой кнопки мыши
- исправлено восстановление состояния GridControl при закрытии формы редактора столбцов
- исправлена ошибка, возникающая при нажатии на кнопку "Отмена" в редакторе колонок объекта Grid
- исправлено отображение метки об изменении отчета при изменении MSChartObject
- исправлено перемещение столбцов элемента управления сеткой в форме редактора столбцов
- исправлены ошибки при перетаскивании объектов из дерева отчета на страницы и вкладку "Код"
- исправлены ошибки в окне конструктора запроса, при добавлении таблицы на рабочую область и при создании связей между таблицами

  [Preview]
+ добавлена подсказка для поля "Копия" в форме "Отправить по E-mail"
- исправлено отображение формы печати при увеличении масштабирования дисплея
- исправлена ошибка, при которой новые экспорты не появлялись в меню
- исправлен порядок переключения клавишей "Tab" в формах экспортов
- исправлен левый отступ RichObject

  [Exports]
+ добавлена опция "Для печати" в RTF экспорте
+ добавлена возможность экспорта денежного формата данных в качестве финансового в Excel 2007 экспорте
+ добавлена опция UseFileStream для экспорта Excel 2007
* увеличены формы экспорта для корректного отображения надписей при разных локализациях
- исправлена ошибка с экспортом линий, нарисованных справа налево или снизу вверх, при экспорте в послойный HTML
- исправлена ошибка экспорта курсивного шрифта Tahoma в PDF
- исправлена ошибка, приводящая к System.ArgumentException при экспорте в поток с включенным свойством ImageExport.SeparateFiles
- исправлена ошибка при SVG-экспорте, когда некоторые фигуры прорисовывались дважды
- исправлена ошибка с экспортом бухгалтерского формата в Excel 2007, при которой не учитывалось количество десятичных знаков
- исправлены утечки памяти в экспортах табличного типа
- исправлена ошибка удаления временного файла при экстренной остановке программы во время экспорта в PDF
- исправлена ошибка экспорта курсивных и полужирных шрифтов в PDF
- исправлена ошибка из-за которой не печатался из браузера фон у объектов с заливкой Solid
- исправлена ошибка с методом set свойства HtmlTemplates.IndexTemplate
- исправлен экспорт 4-байтовых символов в PDF
- исправлен множитель высоты строк при экспорте в RTF
- исправлен множитель высоты строк при табличном экспорте в Word 2007
- исправлена позиция первого объекта на странице с ненулевым значением при экспорте в Word 2007
- исправлена ошибка доступа к временному файлу при экспорте в Excel 2007 с использованием свойств UseFileStream и SplitPages
- исправлена ошибка с локализацией свойства CurrencyToAccounting в Excel 2007 экспорте
- исправлена работа кнопок навигации и отображение нумерации страниц в HTML экспорте
- исправлен подъем и спуск шрифта в PDF-экспорте

  [WebReport]
* переработано свойство WebReport.ReportPrepared, теперь оно связано с соответствующим свойством отчёта
* обновлён дизайн WebReport для FastReport.Core.Web и FastReport.Web.Blazor
- исправлено редкое падение при попытке добавить пустой источник данных в WebReport
- исправлена ошибка, из-за которой не работал Outline в WebReport.LoadPrepared()
— удалена кнопка обновления при загрузке подготовленного отчёта (.fpx)
- исправлена ошибка, из-за которой неверно высчитывалась ширина табов RichObject в WebReport
— удалена возможность выбора страниц в параметрах экспорта для одностраничных отчётов

  [.Net Core]
+ добавлен метод LoadReport, использующий stream вместо string с именем файла для импорта из StimulSoft

  [CoreWin]
- убраны лишние компоненты из тулбара Visual Studio

  [Demos]
* обновлен дизайн демонстрационных отчетов
- исправлена ошибка масштабирования дочерних окон в новом демонстрационном приложении

  [Extras]
+ обновлен плагин FastReportBGObjects, добавлена поддержка диаграммы Bubble
* подключение к ElasticSearch перенесено в отдельный плагин


Версия 2022.3
---------------
  [Engine]
+ добавлен конвертор отчетов из StimulSoft
+ добавлено изменение имени источника данных JSON в выражениях при его переименовании
+ добавлена конвертация свойства PaperSize при конвертации отчетов из StimulSoft
+ добавлена проверка существования связанных сборок при конвертации отчетов из StimulSoft
+ добавлено свойство PrintOnParent у объектов Table и Matrix
+ добавлена загрузка параметров отчета при конвертации отчетов из RDL
+ добавлена загрузка вложенных отчетов при конвертации отчетов из RDL
+ добавлена возможность сохранить данные JSON подключения с помощью свойства StoreData
+ улучшено быстродействие в отчетах, содержащих большое количество объектов
* изменен текст исключения при вычислении и форматировании выражения, если e.InnerException null
* при загрузке RDL отчетов, ширина страницы будет равна ширине секции только в случае, если ширины страницы нет
- исправлено вычисление длины кодировки DataMatrix C40 и текста
- обработано исключение System.ComponentModel.Win32Exception, при печати с отключенным "Диспетчером печати"
- исправлено скрытие границы изображения при печати с автоматическим размером
- исправлена ошибка переполнения стека при подготовке отчета с дочерним бэндом подвала страницы и включенной у него опцией начать новую страницу
- исправлена ошибка, при которой не передавался текущему отчету путь к базовому отчету на Unix ОС
- исправлена ошибка с созданием подотчета и страницы с одним именем при конвертации отчетов из StimulSoft
- исправлена ошибка с некорректными именами при конвертации отчетов из StimulSoft
- исправлена ошибка с TotalPages в Page.VisibleExpression, которая приводит к исключению при выключенном двойном проходе
- исправлена ошибка, при которой бэнд может расти за пределы страницы
- исправлена ошибка, при которой объекты могут расти за пределы бэнда или ContainerObject
- исправлена ошибка обратного отступа при трансляции RTF в объекты отчёта
- исправлен межстрочный интервал для текста транслированного из RichObject
- исправлена ошибка свойства ConnectionString в классе  JsonDataSourceConnectionStringBuilder, когда информация приходила без  заголовков запроса

  [Designer]
+ добавлен валидатор отчета, который помогает находить некорректные объекты (повторяющиеся имена, отрицательные размеры и т.д.)
+ добавлен редактор для свойства RichObject.Text
+ добавлен редактор FRX в дизайнере отчетов
+ добавлено подробное описание связанных сборок и установленных плагинов
+ добавлена возможность копировать диалоговые страницы
+ добавлена возможность удалять диалоговые страницы через контекстное меню
+ добавлена возможность отключить использование последних настроек форматирования при создании объектов
+ добавлена интеграция с FastReport.Id
+ добавлен вызов онлайн-документации в дизайнере отчетов
+ добавлен мастер для визуализации контрольных идентификационных знаков
+ добавлены всплывающие подсказки о правых и нижних отступах для направляющих и объектов в дизайнере
+ добавлена возможность выбирать цвет подсветки пересекающихся объектов в дизайнере
+ добавлена возможность подключения баз Access 2007
* изменен внешний вид формы редактора подключения к ElasticSearch
* изменены текстовые поля в CISWizardForm с единицами измерения на текстовые поля, поддерживающие только числа
- исправлена ошибка, приводящая к System.NullRefereceException при создании вычисляемого столбца для вложенной таблицы JSON
- исправлена ошибка, приводящая к System.FormatException при отрисовке подписей карт
- исправлена ошибка, приводящая к System.NullReferenceException, при нажатии кнопки "Вставить" в контекстном меню диалоговых страниц
- исправлена ошибка масштабирования элементов управления зумом дизайнера в режиме HiDPI при запуске из старого демонстрационного приложения
- исправлено открытие формы сохранения изменений после сохранения всего отчета
- исправлены не масштабируемые элементы в окне приветствия
- исправлена подсветка пересекающихся графиков
- исправлено исключение при переименовании таблицы JSON
- исправлен UpdateStatusBar в DialogWorkspace
- исправлена ошибка локализации кнопки "Учётная запись" в меню "Файл"
- исправлена потеря фокуса выбранного объекта при изменении его свойств
- исправлена ошибка при которой не происходило переключение на страницу "Код" после добавления обработчика событий

  [Preview]
+ реализован экспорт всех открытых вкладок
- исправлена ошибка, приводившая к System.NullReferenceExteption при подготовке отчета с RichObject в системе без принтеров
- исправлена ошибка в объекте MSChart в режиме HiDPI

  [Exports]
+ добавлен экспорт локали в Word, PowerPoint, Rich Text, OpenOffice Write и OpenOffice Calc
+ добавлено шифрование пароля сертификата цифровой подписи в PDF-экспорте при его сохранении
+ добавлена опция "Показать линии сетки" при экспорте в Excel 2007
+ добавлен экспорт типов данных в DBF
+ добавлено новое свойство в экспорт SVG PrefixStyle, которое позволяет задать префикс для всех стилей внутри SVG экспорта
+ добавлена опция "Использовать системное форматирование данных" в  Excel 2007 экспорте
+ добавлено свойство PDFExport.UseFileStream, которое позволяет  экспортировать огромные отчеты на системах с небольшим объемом  оперативной памяти без System.OutOfMemoryException
* установлена UTF-8 в качестве кодировки по умолчанию для экспорта DBF
- исправлено неправильное масштабирование изображений в послойном HTML-экспорте при включенном высоком качестве SVG и увеличении более 1
- исправлена ошибка, приводившая к System.IndexOutOfRangeException при экспорте шрифта без кернинга в PDF
- исправлена ошибка масштабирования изображений при послойном HTML-экспорте
- исправлена ошибка, приводящая к System.NullReferenceException при экспорте отчета с пустой страницей в Word 2007
- исправлена утечка памяти в экспорте PDF с некоторыми CJK шрифтами
- исправлен баг, при котором SVG картинка не поворачивалась на заданный угол в HTML/Blazor экспорте
- исправлен повторный рендеринг ячейки таблицы при экспорте в SVG
- исправлен некорректный стиль страницы при печати из браузера для табличного HTML экспорта
- исправлено исключение, которое возникало при экспорте объекта с отрицательными размерами в HTML формат
- исправлена ошибка экспорта в PDF при Compressed = false
- исправлена некорректная запись свойства border-collapse в табличном HTML-экспорте
- исправлена ошибка Excel-экспорта, при которой заливка в выходном файле не менялась с первого раза
- исправлена ошибка экспорта водяного знака в PostScript
- исправлена ошибка масштабирования шрифта при экспорте в PDF
- исправлена ошибка, при которой текстовый объект с HtmlTags, экспортированный в RTF, не изменялся тегами <br>, <sup>, <sub>

  [WebReport]
* свойства OnlineDesginer перенесены в WebReport.Designer с сохранением обратной совместимости
- исправлен баг, когда событие "CheckedChanged" RadioButton не выполнялось
- исправлено некорректное масштабирование Dialog компонентов в Blazor
- исправлен баг с некорректным размером шрифта при экспорте в Excel
- исправлен баг в Blazor, при котором шрифт текстового объекта со свойством TextRenderType = HtmlParagraph всегда был стандартным

  [.NET Core]
- исправлен некорректный поиск public-методов в скрипте отчёта
- исправлена проблема создания файла fontlist на Azure

  [CoreWin]
- для Visual Studio исправлено поведение компонентов WinForms в Toolbox (Design-Time)
- исправлен некорректный запуск браузера при клике по ссылке в CoreWin
- для FastReport.CoreWin исправлены отчёты со скриптом, которые используют WinForms API

  [Demos]
+ добавлена возможность сменить локализацию нового демо-приложения без его перезапуска
+ добавлено демо-приложение на React с FastReport.Core
- исправлено положение одной из диаграмм в Chart.frx

  [Plugins]
+ реализовано подключение к ЛИНТЕР
+ реализовано подключение к Cassandra
* обновлён RPTImportPlugin

  [Extras]
+ для пакетов FastReport.Net* добавлены библиотеки FastReport.Web (для .NET Framework) и FastReport.VSDesign
+ добавлена возможность импортировать отчёты с помощью потоков

  [Service]
- исправлена некорректная версия FastReport.Compat в пакетах FastReport.Net


Версия 2022.2
---------------
  [Engine]
+ добавлена возможность сохранить отчет со случайными данными
* в методе ExportBand теперь используется аргумент BandBase вместо Base
- исправлены ошибки с двойным вызовом событий AfterData, BeforePrint и AfterPrint объекта ContainerObject
- исправлена ошибка приводящая к System.NullReferenceException при запуске отчетов с диалоговыми формами
- исправлена ошибка, из-за которой не работало свойство VisibleExpression у подотчетов и страниц
- исправлен баг со сдвигом по вертикали непересекающихся объектов при конвертации RTF
- исправлена ошибка с правым якорем на страницах с бесконечной шириной и альбомной ориентацией
- исправлена трансляция списков при конвертации RTF
- исправлена ошибка, из-за которой не работало свойство RichObject.AllowExpressions
- исправлена ошибка, приводящая к System.OverflowException при отрисовке неподготовленной бесконечной страницы

  [Designer]
+ добавлена подсветка пересекающихся объектов
+ добавлена линейка с направляющими в редакторе RichObject
+ заменены символы пароля на точки в инспекторе объектов
+ добавлено предупреждение о возможном переполнении стека при расположении Matrix или AdvMatrix на повторяющиеся бэнды
- удалено сообщение об ошибке, если текст штрих-кода содержит выражение
- исправлена ошибка с опцией отключения горячих клавиш
- исправлено выпадающее меню при нажатии на кнопку LineStyle и LineWidth
- исправлено отображение данных в дизайнере
- исправлены ошибки, приводящие к System.NullReferenceException при перетаскивании объектов на AdvMatrix
- исправлена ошибка с некорректным отображением настроек тени в редакторе границ

  [Preview]
- исправлена ошибка, приводящая к System.NullReferenceException, при щелчке по редактируемому текстовому объекту
- исправлена ошибка с неработающими гиперссылками в отчетах с много-колоночными бэндами
- исправлена ошибка, когда экспорт отчета, приводил к сохранению подготовленного отчета
- исправлена ошибка с настройкой списков доступных экспортов и экспортов в облака в PreviewControl

  [Exports]
+ добавлен экспорт в ZPL II
+ добавлена опция "Высокое качество SVG" в HTML-экспорте
+ добавлена опция "Закрепить ячейки" при экспорте в Excel 2007
+ добавлена возможность масштабирования печати при экспорте в Excel 2007
+ добавлен экспорт закладок и внутренних ссылок в Word
+ добавлен экспорт формата чисел и дат в Excel 97
+ добавлено шифрование персональных данных пользователя в Email-экспорте
+ добавлен экспорт отступа RichObject в RTF
+ добавлен экспорт переноса строки RichObject в RTF
+ добавлен экспорт отступа TextObject в Word
+ добавлен экспорт ширины символов табуляции в PDF, Word, HTML и RTF
+ добавлено свойство PrefixStyle в SVG-экспорте, которое позволяет задать префикс для всех стилей
* улучшен экспорт RichObject в Excel 2007
* удалены экспорты FastReport Cloud и XMPP
- исправлен некорректный поворот альбомной ориентации страниц при HTML-печати, если на них использовались стили с предыдущих страниц
- исправлена ошибка с масштабом шрифта при экспорте в PDF
- исправлена утечка памяти при экспорте SVG объектов в HTML с опцией "Высокое качество SVG"
- исправлена ошибка при встраивании шрифтов, для которых запрещена упаковка, в PDF-экспорте
- исправлена ошибка с экспортом символов табуляции в Word
- исправлена заливка фона изображения и свойство line-height в HTML-экспорте
- исправлена ошибка экспорта пользовательской пунктирной линии SVGObject в PDF
- исправлена ошибка с экспортом границ соединенных ячеек в SVG

  [WebReport]
+ добавлена интерактивность расширенной матрицы в WebReport
- исправлена обработка отмены закрытия веб-диалога в событии OnFormClosing

  [.NET Core]
- исправлена ошибка с неработающей опцией "открыть после экспорта"

  [WebReport Core]
* теперь иконка DatePicker выглядит одинаково во всех браузерах

  [Demos]
+ добавлено новое демо для Blazor, демонстрирующее работу с двумя отчетами 
- исправлена ошибка, из-за которой не менялся курсор при наведении на ссылки в новом демо
- исправлена ошибка с AdvMatrix в новой демо

  [Plugins]
+ добавлено подключение к Excel
- исправлен SQLite коннектор для FastReport.Core, FastReport.CoreWin и FastReport.OpenSource
- исправлена строка подключения к Firebird

  [Extras]
+ добавлена утилита для конвертации RTF документов в шаблоны отчетов. (\Extras\Misc\rtf2frx)


Версия 2022.1
---------------
  [Engine]
+ добавлен новый объект AdvMatrixObject
+ добавлены штрих-коды GS1 DataBar: Limited, Omnidirectional, Stacked и Stacked Omnidirectional
+ добавлены новые свойства: Config.CompilerSetting.ExceptionBehaviour и Config.CompilerSetting.Placeholder.
> эти свойства дают возможность настраивать поведение при возникновении исключений с некорректными именами полей и таблиц баз данных.
+ добавлена трансляция RichObject внутри TableCell
* переработана трансляция RichObject в объекты отчёта
- исправлен ShiftMode транслированных из RTF текста объектов
- исправлена ошибка с двумя параметрами с одним именем приводящая к исключению System.ArgumentException
- исправлена ошибка с вложенным отчетом содержащим многоколоночный Databand
- исправлена ошибка с неверным расчетом высоты бэнда
- исправлена ошибка с отображением гиперссылок при конвертации RTF в объекты отчета
- исправлена трансляция RichObject если документ назначается из скрипта
- исправлена ошибка с шрифтами, добавляемыми в Config.PrivateFontCollection

  [Designer]
+ добавлена проверка вводимых данных в окне редактирования QR-кода СберБанка
- исправлена ошибка с переносом строки в редакторе текстового объекта
- исправлена ошибка конвертации отчетов rdl, содержащих матрицы внутри ячеек таблицы
- исправлена ошибка с направляющими линиями в дизайнере
- исправлена ошибка с окном "Дерево отчета"
- исправлена ошибка приводящая к System.NullReferenceException и падению дизайнера во время его запуска при включенной опции Авто-направляющие

  [Preview]
- исправлена ошибка со сдвигом позиции объектов при переключении вида бэндов во время редактировании подготовленной страницы

  [Exports]
+ реализован экспорт водяных знаков в Word
+ реализован экспорт водяных знаков в RTF
+ добавлена опция "Не поворачивать альбомные страницы при печати" при экспорте в HTML
+ добавлена возможность изменять имя прикрепляемого файла при отправке по Email
+ добавлено масштабирование SVG изображений в матрице экспорта
+ добавлена возможность экспорта свойства, определяющего размер и расположение изображения при экспорте в Excel 2007
+ реализована возможность скрывать или показывать линии сетки при экспорте в Excel 97
+ реализован экспорт групп на отдельные листы в Excel
+ реализован экспорт уровня прозрачности изображений водяных знаков в Word
+ реализован экспорт размера изображения водяного знака в RTF
- исправлена ошибка, приводившая к System.NullReferenceException при экспорте в текст, таблиц с количеством строк меньше одной
- исправлен некорректный левый отступ таблиц при экспорте в Word
- исправлена ошибка со шрифтом Wingdings в тегах HTML при экспорте в HTML
- исправлен баг с экспортом шрифтов Wingdings и Webdings в HTML
- исправлена ошибка с шириной фреймов при экспорте в PowerPoint
- исправлена ошибка экспорта объектов с прозрачной заливкой в RTF
- исправлена ошибка экспорта объектов с прозрачной заливкой в Word
- исправлена ошибка, приводящая к System.OutOfMemoryException при экспорте в PDF
- исправлено неправильное отображение переноса строки при экспорте в HTML
- исправлено переполнение памяти при экспорте в PDF
- исправлены ошибки в PDF-экспорте на системах, отличных от Windows
- исправлена ошибка с экспортом таблиц с количеством столбцов больше 63 в Word 2007
- исправлена ошибка приводящая к утечке памяти и исключению System.OutOfMemoryException в PDF-экспорте при включенной опции "Текст в кривых"
- исправлена ошибка с разрывом строки при экспорте в HTML

  [WebReport]
- исправлена ошибка с символом новой строки при использовании шрифта Wingdings

  [.Net Core]
+ добавлена поддержка .NET 6
- исправлен некорректный поиск Bold-Italic шрифтов

  [WebReport Core/Blazor Server]
+ добавлены возможности настраивать свойства экспорта отчёта из WebReport.
> При активации свойства webReport.Toolbar.Exports.EnableSettings рядом с кнопкой необходимого экспорта появится иконка настройки
+ добавлено свойство webReport.SplitReportPagesInTabs, которое позволяет разделить разные страницы отчёта (ReportPage) в разных вкладках WebReport
+ добавлены статические имена классов для возможности переопределить стандартные стили тулбара, outline и других элементов
- исправлено обновление WebReport при вводе значения с клавиатуры в поле DateTimePicker
- исправлена ширина табов (tabs) при нестандартных размерах страницы отчёта

  [Demos]
+ добавлена демо использования WebReport Core для .NET 5
+ добавлена демо использования WebReport Core для Angular
+ добавлена демо использования WebReport Blazor для Blazor Server


Версия 2021.4
---------------
  [Engine]
+ добавлено подключение к ElasticSearch
+ добавлен новый штрих-код - Japanese PostNet
+ добавлен метод Res.LoadLocale(CultureInfo), который изменяет выбранную локаль по аргументу CultureInfo. Загруженные локали кэшируются. Для корректной работы требуется добавленный пакет FastReport.Localization
* оптимизирован и унифицирован конвертор RichText в объекты отчёта
- исправлена ошибка с неправильной шириной табуляции при TextObject.TextRenderType = TextRenderType.HtmlTextRenderer
- исправлена ошибка с объектом "Вложенный отчет" на бэнде "Подвал страницы", приводящая к переполнению стека
- исправлена ошибка со свойствами Dock и Anchor у объектов внутри ячеек таблицы/матрицы
- исправлена ошибка, приводящая к System.ArgumentException при отрисовке PictureObject расположенными за пределами бэнда
- исправлена ошибка с некорректной работой правого якоря (Anchor = AnchorStyles.Right) при неограниченной ширине страницы
- исправлена ошибка с заменой пользовательского шрифта на шрифт, по умолчанию при подготовке отчета
- исправлена ошибка с выравниванием по вертикали при конвертации RTF (по умолчанию теперь Top вместо Center).
- исправлена ошибка конвертации таблиц RTF в объекты отчета

  [Designer]
+ добавлено упрощенное отображение имен полей БД в дизайнере
+ добавлена кнопка свернуть все/развернуть все, и поле поиска для дерева отчетов и дерева данных
+ добавлены новые иконки. Вы можете выбрать их в окне дизайнера "Вид/Настройки/Интерфейс".
- исправлена ошибка, приводящая к падению дизайнера отчётов, при некорректной таблице в источнике данных

  [Preview]
- исправлена ошибка сохранения подготовленных отчётов, содержащих сконвертированный RichObject

  [Exports] 
+ добавлена опция при экспорте в Word 2007 "Не добавлять разрывы разделов при разрывах страниц". По умолчанию добавляются и разрывы страниц, и разрывы разделов.
- исправлен разрыв страницы в Html экспорте (свойство PageBreaks)
- исправлен SVG экспорт с параметром "Экспорт в несколько файлов"
- исправлена ошибка в SVG экспорте на мониторах с высоким разрешением
- исправлены имена фалов, сохраняемых в zip архив
- исправлена ширина табуляции при экспорте RichObject
- исправлена ошибка XPS-экспорта, при которой документы, экспортированные на Linux, не открывались на Windows
- исправлены ошибки некорректной работы свойств Anchor и Dock при экспорте страниц с бесконечной шириной 
- исправлена ошибка экспорта текстовых объектов в Excel 2007 с включенным типом рендеринга HtmlParagraph. Отключите параметр экспорта WYSIWYG, чтобы экспортировать текст вместо изображений.

  [WebReport]
+ добавлена поддержка Blazor компонентов для пакета FastReport.Core3.Web
+ для диалогов в WebReport добавлена поддержка background-color
+ для диалогов в WebReport добавлена поддержка свойства Enabled
+ для диалогового компонента TextBox в WebReport добавлена поддержка свойства MaxLength
* оптимизирована загрузка локализации для Toolbar
- исправлен некорректный вывод мультистрочного текста в Blazor (Interactive Forms & TextBox)
- исправлен некорректный фоновый цвет страницы при HTML/Blazor экспорте на браузерах Safari
- для диалогового компонента Label в WebReport исправлено отсутствие переносов строк
- исправлена ошибка с зависанием обратного вызова сохранения онлайн-дизайнера в WebReport с сессиями
- исправлены ошибки некорректной работы свойств Anchor и Dock на страницах с бесконечной шириной

  [Online Designer]
- исправлено сохранение/вызов превью из Онлайн-Дизайнера со страницей в Landscape ориентации

  [.Net Core]
+ добавлена поддержка Single File Application
* обновлены зависимости к FastReport.Compat и FastReport.DataVisualization. FastReport.Compat теперь правильно определяет возможность использования WinForms API. FastReport.DataVisualization теперь не имеет зависимость к System.Data.SqlClient и System.Drawing.Common
- исправлена ошибка, при которой отчет не работал с данными из пользовательской библиотеки, хотя она была зарегистрирована в ReferencedAssemblies в CoreWin
- исправлен вылет приложения при загрузке отчета с неизвестным шрифтом в нескольких потоках на Linux
- исправлена ошибка "Could not load type 'System.Drawing.Design.UITypeEditor'"
- исправлена загрузка имен таблиц в XmlDataConnection
- исправлена ошибка, из-за которой не загружался отчёт и ресурсы при публикации/отладки используя IIS/IIS Express. Для корректной работы, необходимо вызывать метод `UseFastReport()` перед 'UseMvc/UseEndpoints'

  [WebReport Core]
+ добавлены xml комментарии (DocumentationFile) к Web библиотекам
+ добавлено свойство для отключения отображения тулбара на диалоговой странице отчета: webReport.Toolbar.ShowOnDialogPage
+ добавлено больше экспортов в выпадающем меню тулбара. Данные свойства доступны в webReport.Toolbar.Exports
+ добавлена возможность настройки тулбара: Положение, цвет выпадающего меню, шрифт, прозрачность иконок, изменение цвета иконок, изменение положения контента. Данные свойства доступны в webReport.Toolbar
+ диалоговый DateTimePicker для WebReport был улучшен. В режиме DateTimePicker.Format.Time он отображает только время, в режиме DateTimePicker.Format.Short - только дату, DateTimePicker.Format.Long - и дату, и время.

  [Extras]
+ добавлен пакет 'FastReport.Localization', который включает в ваш проект файлы локализации FastReport для работы с разными языками
+ добавлены объекты интеграции с FastReport Business Graphics (\Extras\Objects\FastReportBGObjects)

  [Demos]
+ реализован переход к списку отчетов, при нажатии на стрелку на папке в новом демо
* изменен target framework для нового демо на 4.7.2
* изменен цвет неактивных кнопок в режиме отображения миниатюр нового демо
* изменен цвет фона ползунка масштабирования в новом демо
* изменен цвет фона при отображении диалоговых форм в новом демо
* изменен цвет фона вкладок интерактивных отчетов в новом демо
* изменено расположение папки с миниатюрами отчетов для демонстрационного приложения. Теперь эта папка располагается не в Program Files а в AppData\Local
- исправлены проблемы с отображением элементов интерфейса нового демонстрационного приложения
- исправлена ошибка, вызывающая сохранение подготовленного отчета при нажатии на раскрывающиеся элементы в меню сохранения нового демонстрационного приложения
- исправлена ошибка с выравниванием отчетов в окне предварительного просмотра нового демо
- исправлена ошибка двойного запуска диалоговых форм при выборе отчета в новом демо
- исправлена ошибка с растяжением миниатюр в новом демо
- исправлена ошибка, приводящая к задержке при перемещении окна нового демо
- исправлена ошибка нового демо с одновременным отображением миниатюр в панели папок и в панели отчета

  [Plugins]
* обновлены пакеты с плагинами-коннекторами FastReport.Data.**. Теперь они включают в себя плагины для разных редакций FastReport (.NET, Core, CoreWin, OpenSource) и автоматически подключают нужную библиотеку, в зависимости от используемого продукта
* postgres npgsql понижение версии с 4.0.3 до 3.2.7


Версия 2021.3
---------------
  [Engine]
+ добавлена поддержка HiDPI в новом демо-приложении
- исправлена ошибка при которой размеры страницы могли сбрасываться после предварительного просмотра
- исправлена ошибка при которой печать объекта RichText на большом масштабировании Windows происходила некорректно
- исправлена ошибка, приводящая к System.ArgumentOutOfRangeException в функциях Substring
- исправлена ошибка, приводящая к System.ArgumentException при отрисовке PictureObject с некоторыми изображениями
- исправлена ошибка при которой не отображались таблицы при подключении к Advantage Database через ODBC
- исправлена ошибка при которой RichText выходил за пределы страницы
- исправлена ошибка перекомпиляции скрипта отчёта, который взаимодействовал с ChildBand

  [Designer]
+ улучшено поведение панели страниц
- исправлена ошибка с выходом за пределы массива в SQLBuilder в дизайнере
- исправлена ошибка при которой не открывалась диалоговая страница если в ней есть GridControl
- исправлены ошибки в режиме Right to Left
- исправлена ошибка при повторном масштабировании диалоговой формы

  [Preview]
- исправлена ошибка при которой проценты масштаба в Preview могли отображаться некорректно

  [Exports]
+ добавлен экспорт в XODT
+ добавлен экспорт в XODS
- исправлена ошибка экспорта в ODF при которой документ не открывался в МойОфис
- исправлена ошибка с закрытием ячейки содержащей RichText при экспорте в RTF
- исправлена ошибка при экспорте объектов с режимом рендеринга HtmlParagraph
- исправлена ошибка экспорта линии со стрелочным указателем при послойном экспорте в Word 2007
- исправлена ошибка экспорта линии со стрелочным указателем при экспорте в PowerPoint 2007

  [WebReport]
+ добавлены Razor компоненты для встраивания в Blazor Server приложения. Входит в состав пакета FastReport.Web и находится по пути: FastReport.Web.Blazor.Components. Для отображения отчёта рекомендуется использование компонента WebReportContainer 
- исправлена ошибка в WebReport Core с SinglePage и диалогами
- исправлена проблема компиляции скрипта VB.NET, приводящая к ошибке "Модуль не может быть общим"

  [.Net Core]
* обновлена зависимость Microsoft.CodeAnalysis до версии 3.3.1
* обновлена зависимость FastReport.Compat до версии 2021.1.4
- исправлена ошибка с некорректными картинками при PDF экспорте на Linux
- исправлена ошибка, приводящая к System.NullReferenceException при вызове CsvDataConnection.CreateAllTables()

  [Extras]
- исправлена ошибка с некорректной загрузкой имен таблиц из ClickHouse


Версия 2021.2
---------------
  [Engine]
+ добавлена поддержка HiDPI
+ добавлена агрегатная функция CountDistinct (итоги отчета и итоги объекта Матрица)
+ добавлена поддержка TLS 1.2
+ добавлены 2 новых типа UncheckedSymbol для CheckBox
+ добавлена возможность запретить загрузку данных форматов XML и CSV локально
+ добавлена возможность загружать источник данных XML по URL
+ добавлена возможность изменить шрифт для восточно-азиатских языков в Word2007-экспорте
+ добавлены функции преобразования чисел в слова для польского языка
+ добавлены универсальные пакеты для Windows, нацеленные на .NET Framework 4.x, .NET Core 3.1 и .NET 5
* оптимизировано копирование потоков в некоторых случаях
- исправлены ошибки при импорте отчетов DevExpress
- исправлены ошибки при импорте отчетов RDL
- исправлена ошибка при которой бэнд с включенным свойством FillUnusedSpace, не выводился еще раз, хотя свободного места достаточно
- исправлены ошибки при импорте отчетов List and Labels
- исправлена ошибка при которой свойство AutoSize для SvgObject работало неправильно
- исправлена ошибка с TextObject.AutoShirnk=FontSize при очень маленьком размере TextObject
- исправлена ошибка с некорректным значением переменной TotalPages при ее использовании в VisibleExpression
- исправлена ошибка с неполным копированием матрицы при копировании страницы отчета
- исправлена ошибка с преобразованием RichText, когда значение RichObject.Text равно null

  [Designer]
+ добавлена возможность копировать источник данных
+ добавлен импорт отчетов DevExpress сохраненных в формате XML
+ добавлена возможность добавлять текст и картинки перетаскиванием их из браузера
- исправлена ошибка при добавлении штрих-кода, при которой создавался штрих-код не того типа
- исправлена ошибка при которой при перетаскивании из функций создавался NUD и пустой текстовый объект
- исправлена ошибка при которой в диалоговых окнах неправильно отрисовывался RichTextBoxControl
- исправлены проблемы с масштабированием в окнах WelcomeForm и Wizard
- исправлена вкладка SberbankQR в редакторе баркодов
- исправлена ошибка при копировании объекта, когда создавался объект с таким же именем

  [Preview]
- исправлена ошибка, приводящая к System.ObjectDisposedException при повторной подготовке отчета

  [Exports]
+ добавлена поддержка стандарта ODF 1.2 при экспорте в ODT/ODS
- исправлено сохранение отчета в Box
- исправлено сохранение отчета в OneDrive
- исправлено сохранение отчета в GoogleDrive
- исправлена ошибка, приводящая к System.OutOfMemoryException при экспорте в PDF
- исправлена ошибка создания некорректного файла при экспорте в Excel 2007 с большим количеством страниц и опцией разрывов страниц
- исправлена ошибка при которой экспорт в изображение не учитывал прозрачный фон отчета
- исправлена ошибка, приводящая к System.NullReferenceException при экспорте в Excel 2007
- исправлены ошибки валидации при экспорте в ODT/ODS
- исправлена ошибка экспорта в ODT при которой файл некорректно открывался в Word 2019
- исправлена ошибка с некорректным расположением линии при экспорте в Word 2007 

  [WebReport]
- исправлено сохранение отчётов в Онлайн Дизайнере без изменений
- исправлена ошибка с неправильными отступами между объектами при предпросмотре

  [.Net Core]
+ добавлено больше ссылок на библиотеки .NET Standard для корректной компиляции скрипта отчета
- исправлена установка свойства EnableScriptSecurity перед инициализацией класса Report
- исправлена проверка WebMode для .NET Core

  [Mono]
- исправлена проблема с некорректным отображением меню

  [Extras]
+ исправлены незначительные баги в новом демо приложении
* обновлен плагин FastReport.RPTImportPlugin для использования пакетов
- исправлена ошибка получения пустых коллекций
- исправлена ошибка с подключением к PostgreSQL 12 и более новым. Коннектор находится в папке \Extras\Core\FastReport.Data\FastReport.Data.Postgres


Версия 2021.1
---------------
  [Engine]
+ добавлена поддержка .NET 5
+ добавлен новый штрих-код - Deutsche Post Leitcode
+ добавлен новый штрих-код - QR-код СберБанка
+ добавлены функции преобразования чисел в буквы
+ добавлены функции преобразования чисел в слова для индийского языка
+ добавлен символ рупий для индийской валюты
+ добавлены функции преобразования чисел в слова для персидского языка
+ добавлены функции преобразования чисел в слова для украинского языка
+ добавлен метод Report.Prepare(int pagesLimit), позволяющий подготовить ограниченное количество страниц
* оптимизирована работа свойств VisibleExpression, PrintableExpression и ExportableExpression для бэндов
* улучшен алгоритм конвертации RTF в объекты отчета
- исправлен ошибка со StreamReader при подключении к удаленному JSON
- исправлена ошибка компиляции отчета при некоторых выражениях в свойствах VisibleExpression, PrintableExpression и ExportableExpression
- исправлена ошибка c файлом font.list, приводящая к исключению System.IO.FileNotFoundException
- исправлена ошибка с неправильным вычислением контрольный суммы для штрих-кода Deutsche Post Identcode
- исправлен ReCompile (добавление сборок после компиляции с ошибкой)

  [Designer]
- исправлена ошибка с пустым именем базы данных после перезагрузки отчета
- исправлена ошибка, при которой двойное нажатие по кнопкам-стрелкам на панели отчета создавало новые страницы

  [Exports]
- исправлена ошибка экспорта строк, содержащих только пробелы, при экспорте в DXF
- исправлена ошибка в PDF экспорте, приводящая к исчезновению пробелов при наличии в отчете символов табуляции
- исправлена ошибка экспорта подвалов страниц при экспорте в Excel 2007 в режиме бесшовной таблицы
- исправлена ошибка экспорта символа "\" при экспорте в Excel 2007

  [WebReport]
+ добавлено корректное описание ошибок в режиме ScriptSecurity
- исправлена ошибка PDF-экспорта в онлайн дизайнере
- исправлена ошибка с ParagraphOffset

  [.Net Core]
+ для WebReport добавлены свойства ShowDbfExport, ShowMhtExport, PrintInHtml, PrintInPdf которые позволяют включать/отключать отображение кнопок в тулбаре соответствующих экспортов/печатей
* теперь производится проверка и StubClasses не добавляются для консольных приложений и библиотек
- исправлена ошибка с выражениями RichObject
- исправлена ошибка экспорта MSChartObject при экспорте в Power Point 2007
- исправлена ошибка экспорта картинок при экспорте в Excel 2007 на Windows

  [Resources]
* обновлены французские ресурсы

  [Extras]
* изменена зависимость в проекте конвертора Crystal Reports с System.Windows.Forms.DataVisualization на FastReport.DataVisualization
* обновлен плагин для подключения к MongoDB в Core и OpenSource


Версия 2020.4
---------------
  [Engine]
+ добавлен новый штрих-код ITF-14
+ добавлен новый штрих-код Deutsche Post Identcode
+ добавлена возможность выравнивания штрих-кодов
+ добавлено свойство PictureObject.ImageSourceExpression, позволяющее установить выражение, содержащее источник изображения
+ добавлена возможность использовать выражения, заключенные в квадратные скобки в свойствах VisibleExpression, PrintableExpression и ExportableExpression
+ добавлено свойство PictureObject.ImageFormat, позволяющее выбрать формат хранения изображения
* FastReport.DataVisualization теперь добавлен в списке сборок по умолчанию (FR .Net, FR.Core)
- исправлена ошибка, приводящая к исключению, при включенном свойстве "Формировать новую страницу" у дочернего бэнда заголовка страницы
- исправлена ошибка, при которой значение выражения отображалось текстом этого выражения
- исправлена некорректная отрисовка штрих-кода ITF-14
- исправлена ошибка с прозрачностью RichObject

  [Designer]
+ добавлена возможность редактировать количество строк и столбцов таблицы перетаскиванием мыши
+ добавлена загрузка RTF текстов, таблиц и стилей при загрузке DevExpress файлов
+ добавлена возможность загрузки CSV файлов через URL
* обновлен плагин для подключения к MongoDB, до актуальных версий MongoDB
* изменен порядок фокуса элементов при нажатии tab на вкладке с созданием SwissQR
- исправлена ошибка, при которой у окна редактирования датчиков была неправильная ширина
- исправлена ошибка, при которой переключение свойств на алфавитный порядок не работало
- исправлена ошибка загрузки размера страницы при конвертировании DevExpress файла
- исправлена ошибка, при которой пустая строка в штрих-коде Datamatrix приводила к исключению

  [Exports]
+ добавлен экспорт в PDF/A-2u
+ добавлено свойство ReportPage.ExportAlias, позволяющее задать имя страницы при экспорте в Excel 2007
* теперь в Excel 2007 экспорте для листов без изображений не создаются файлы с описанием изображений и связи к ним
- исправлена ошибка при экспорте в Excel 2007 в режиме "Без разрывов таблицы", приводящая к разрывам таблицы
- исправлена ошибка при экспорте в Excel 2007 в режиме «Без разрывов таблицы», приводившая к некорректному объединению ячеек
- исправлена ошибка при экспорте в Excel 2007 в режиме «Без разрывов таблицы», приводившая к некорректному экспорту изображений
- исправлена ошибка, при которой ссылки с русскими буквами не работали в PDF экспорте
- исправлена ошибка, при которой даты создания и редактирования документа не соответствовали эквивалентным в метаданных в PDF/A-1a экспорте
- исправлена ошибка при экспорте в Excel 97, приводящаю к исключению "Huge SAT not implemented"
- исправлена ошибка при экспорте текстов, содержащих амперсанд '&', в Excel 2007 экспорте
- исправлена ошибка при экспорте MapObject в PowerPoint
- исправлена ошибка сохранения темы по умолчанию при экспорте в Excel 2007
- исправлена ошибка с экспортом градиентных заливок с паролем владельца или пользователя при экспорте в PDF
- исправлена ошибка с шифрованием цифровой подписи в PDF-экспорте при защите документа паролем
- исправлена ошибка со смещением параграфов при экспорте в OpenOffice Writer

  [WebReport]
+ добавлена проверка скрипта отчёта на вредоносный код. Эта опция включена по умолчанию для Web.
- исправлена ошибка, при которой объекты с Exportable = false были не видны в WebPreview
- исправлена ошибка, при которой отсутствовали некоторые фигуры при печати из браузера
- исправлен некорректный расчёт размеров страницы в FastReport.Core.Web, если хоть одна страница была в ландшафтной ориентации

  [.Net Core]
+ добавлены "Диалоги" для WebPreview FastReport.Core
* теперь FastReport.DataVisualization не нужно добавлять в References в пользовательском приложении на .NET Core3
* теперь собрать вариант FastReport.Core и FastReport.OpenSource под netstandard2.1 можно только на поддерживаемых версиях VisualStudio (MSBuild)
- исправлена проблема с пользовательскими приложениями на .NET Core3, ссылающимися на FastReport.Core. Теперь FastReport.Compat не нужно добавлять в References в пользовательском приложении.

  [Demos]
+ добавлено новое демонстрационное приложение
* обновлены ссылки на различные пакеты FastReport в демо-приложениях до актуальных версий


Версия 2020.3
---------------
  [Engine]
+ добавлен новый тип QR-кода, Swiss QR Code
+ добавлено свойство MatrixObject.PrintIfEmpty, позволяющее отображать матрицу даже если она пуста
+ добавлено свойство Page.LastPageSource, позволяющее настраивать лоток принтера для печати последней страницы отчета
+ добавлены свойства VisibleExpression, PrintableExpression и ExportableExpression
> эти свойства позволяют задавать значение свойств Visible, Printable и Exportable, в зависимости от выполнения заданного условия
* прекращена поддержка .NET Framework 2.0
- исправлена ошибка с видимостью текстового объекта, при включенном параметре Visible у Highlight
- исправлена ошибка с работой свойства PrintableExpression

  [Designer]
- исправлена ошибка, при которой перетакскивание в матрицу не работало
- исправлена ошибка, приводящая к System.FormatException при открытии файлов DevExpress
- исправлена ошибка "Значение счетчика не может быть меньше нуля." при открытии файлов DevExpress
- исправлена ошибка с перемещением объектов в дереве отчета при нажатой клавише Ctrl
- исправлена ошибка с выпадающим меню кнопки выбора цвета

  [Preview]
- исправлена ошибка с настройкой списка экспортов с помощью Config.PreviewSettings
- исправлена ошибка, при которой сохранить отчет можно было только в Box, независимо от выбранного в меню облачного хранилища

  [Exports]
* оптимизировано сохранение встраиваемых шрифтов при экспорте в PDF. Размер файлов значительно уменьшился.
- исправлена ошибка с некорректными отступами при экспорте в OpenOffice Writer
- исправлена ошибка с некорректным размером картинки при экспорте в RTF
- исправлена ошибка с разбиением на страницы при экспорте в OpenOffice Writer
- исправлена ошибка со смещением параграфов при экспорте в OpenOffice Writer
- исправлена ошибка с выравниванием текста по ширине при экспортах в OpenOffice Writer и OpenOffice Spreadsheet
- исправлена ошибка при экспорте в Excel (BIFF8)

  [WebReport]
- исправлена ошибка загрузки ресурсов в WebReport (OpenSource)
- исправлена ошибка масштабирования изображений в WebReport
- исправлена ошибка "Превышено время ожидания запроса" во время сохранения отчёта из Онлайн Дизайнера
- исправлена ошибка с вызовом WebReport.ExportPdf, WebReport.ExportCsv, WebReport.ExportRtf и т.д.

  [.Net Core]
* исправлена ошибка компиляции FastReport.Core и FastReport.OpenSource на Unix-системах (из-за net40 в targetFrameworks)
- исправлены ошибки с некоторыми API в коде отчёта, доступными в System.Drawing.Primitives
- исправлена неработающая кнопка "Открыть после экспорта" в FR.Core3


Версия 2020.2
---------------
  [Engine]
+ добавлено свойство Report.Tag
+ добавлено свойство AutoEncode для DataMatrix Barcode. По умолчанию, при значении true, управляющий символ &1; кодируется как символ FNC1. При значении false, символ кодируется как есть.
+ добавлено событие OnScriptCompile, вызываемое при компиляции скрипта отчета
+ добавлены новые TextQuality: SingleBitPerPixel и SingleBitPerPixelGridFit
+ добавлена возможность разбивать строки таблицы
+ добавлены валюты RUB, BYN и BBYN в функцию ToWordsRu
- исправлена ошибка, при которой перенос вложенного отчета на новую страницу работал некорректно
- исправлена ошибка, при которой подвал данных отрывался от данных при включенном свойстве "не отрывать от данных"
- исправлена генерация штрих-кода GS1-128
- исправлено API для редактирования меню экспортов в PreviewControl
- исправлено некорректное значение Итога, если он ссылался на другой Итог
- исправлена ошибка, при которой таблица переносилась некорректно
- исправлена ошибка парсинга xml с шестнадцатеричными параметрами, например "To create it:&#xD;&#xA;"

  [Designer]
+ добавлена возможность открывать страницу вложенного отчета по двойному нажатию на его объект
+ добавлена возможность менять шрифт во вкладке с кодом, окне редактирования текста и окне редактора формул
+ добавлена возможность замены картинок при перетаскивании
+ добавлена возможность горизонтальной прокрутки отчета при зажатой клавише Shift
+ добавлена возможность открывать файл отчета перетаскиванием
+ добавлена подсветка бэнда, на который будет помещен объект при перетаскивании
* теперь при смене окна контекстное меню закрывается
* теперь в момент автосохранения выбранный пункт из окна свойств не сбрасывается
- исправлена ошибка при изменении параметров, сразу после добавления линии, вызывающая исключение
- исправлена ошибка при создании штрих-кода Intelligent Mail
- исправлена ошибка с JSON-подключением в Мастере Подключения к Данным
- исправлена ошибка с неправильной отрисовкой горизонтальных направляющих
- исправлена ошибка, при которой ширина объектов сбрасывалась после закрытия Preview при включенном правом якоре

  [Preview]
+ добавлена кнопка "О программе" в панели инструментов предварительного просмотра
+ добавлена возможность горизонтальной прокрутки отчета при зажатой клавише Shift

  [Exports]
+ добавлен экспорт в DXF
+ добавлена поддержка стандарта PDF/A-1a в PDF-экспорте
- исправлена ошибка печати при послойном Html-экспорте, если в отчёте были листы с ландшафтной ориентацией страниц
- исправлена ошибка, при которой экспорт в EMF вызывал исключение
- исправлено отображение объектов с отрицательной высотой/шириной при послойном экспорте в Html

  [WebReport]
- исправлено свойство Exportable для бэндов и объектов в режиме WebPreview

  [.Net Core]
+ добавлена версия FastReport для Core 3/3.1 для Windows
+ добавлена поддержка MSChart
+ добавлены Функции в Онлайн Дизайнер
* обновлены зависимости nuget до релизных версий вместо предварительных
* изменен модификатор доступа PrintPdf и PrintHtml
* добавлен новый метод для сохранения отчётов в Онлайн-дизайнере - DesignerSaveMethod, метод DesignerSaveCallBack - устарел, его использование не рекомендуется


Версия 2020.1
---------------
  [Engine]
+ добавлены события для управления шрифтами. Подробности в новой демонстрационной программе - .\Demos\C#\FontHandlersExportToPDF 
+ добавлена возможность изменять количество знаков после запятой для форматов Числовой, Денежный и Процент, при использовании системных настроек
+ добавлено свойство "SplitRows" для MatrixObject. По умолчанию его значение False и в этом случае происходит объединение строк с одинаковыми значениями. Если True - строки разбиваются (как у TableObject)
- исправлена ошибка с попыткой преобразовать DBNull в пустую строку при отключенном ConvertNulls
- исправлена ошибка, при которой PageFooter с включенным PrintOn=LastPage, выводился на предпоследней странице

  [Designer]
+ добавлена возможность перетаскивать на страницу изображения в форматах png, jpeg, jpg, gif, ico, bmp, tif, tiff, emf, wmf и текстовые файлы в форматах txt и rtf
+ добавлена возможность вставлять текст и изображение на страницу из буфера обмена
+ добавлена возможность создавать новую страницу отчёта с помощью: кнопки "+" на панели страниц, двойным нажатием на свободное место на панели страниц, сочетанием клавиш Ctrl+N
- исправлена ошибка при попытке задания некорректного значения RowSpan ячейке MatrixObject
- исправлена ошибка со сбрасыванием цвета, ширины и стиля в редакторе границ
- исправлена ошибка с изменением размера PolyLineObject/PolygonObject, скопированного с помощью Ctrl+Button
- исправлена ошибка с неактивным контекстным меню "Режим отображения" у SVG-объекта
- исправлена ошибка, когда невозможно было удалить вложенный отчет, если связанная с ним страница удалена
- исправлена ошибка, когда кнопки в разделе "Панели" вкладки "Вид" не соответствовали видимости соответствующих окон

  [Preview]
+ добавлен редактор меню экспортов
> новый редактор доступен в настройках пользовательского интерфейса; имеется возможность скрыть экспорт или меню экспорта
* теперь меню с источниками данных скрыто в редакторе текста в окне предварительного просмотра
* кнопка "Удалить Страницу" в окне предварительного просмотра теперь неактивна, если подготовленный отчет состоит из одной страницы

  [Exports]
+ добавлена возможность разделить страницы в XML-экспорте
+ добавлена поддержка свойства Padding для текстовых объектов в Word2007
* теперь в PDF-экспорте при InteractiveForms = true шрифты не сохраняются, если в отчете нет редактируемых элементов
- исправлены ошибки при экспорте многостраничного отчёта в XML
- исправлена ошибка в PDF-экспорте приводящая к созданию некорректного файла при включенных свойства EmbeddingFonts и InteractiveForms
- исправлено отображение фона у BarcodeObject при экспорте в Pdf и HTML
- исправлены ошибки при отображении Shape, Barcode, Polygon и т.д. с заливкой (или фоном) во всех табличных экспортах

  [WebReport]
+ добавлена возможность изменять параметры экспорта. Для этого нужно подписаться на событие ExportParameters в WebReport.Report
- исправлена неправильная высота и ширина у отчетов со смешанной ориентацией страниц (Landscape & Portrait)
- исправлено некорректное отображение фона у ShapeObject
- исправлено отсутствие нестандартной заливки (Hatch, LinearGradient, и др.) у ShapeObject

  [.Net Core]
- исправлена ошибка с SQLite плагином, при наличии в базе данных Null значений
- исправлена критическая ошибка при внедрении шрифтов в документы


Версия 2019.4
---------------
  [Engine]
+ добавлен новый формат времени минуты:секунды [mm:ss]
+ добавлена кривая Безье для полигонов
+ добавлено новое подключение к данным Json, интегрированное в движок
+ добавлено свойство FontListFolder в Utils.Config
+ добавлено свойство RepeatBandNTimes для бэндов
* обновлён объект полигон: теперь тулбар отображается не рядом с объектом, а на панели инструментов и в Ribbon; изменены режимы работы полигона, новые режимы позволяют редактировать и добавлять кривые
> полигоны претерпели сильные изменения, и мы хотим подробнее описать изменения, полигон имеет 5 режимов редактирования: первый позволяет работать с объектом целиком, второй для выделения и перемещения точек, третий позволяет добавлять новые точки на полигон, четвертый позволяет редактировать кривые, пятый для удаления точек полигона. Для 3-го и 4-го режима необходимо выделить точку
- исправлен подбор размера изображения, при включённом AutoSize на этапе подготовки
- исправлено отображение списков при трансляции RichObject в объекты отчёта 
- исправлена ошибка, когда шрифт, измененный в родительском отчете, не изменялся в унаследованном отчете
- исправлена ошибка с изменением иерархии GroupHeaderBand, если у него был дочерний GroupHeaderBand

  [Designer]
+ добавлена возможность редактирования SQL-запроса для встроенного QueryBuilder, если QueryBuilder не может обработать запрос, будет выдано предупреждение
* теперь при изменении имени источника данных, его имя меняется в выражениях TextObject.Text, PictureObject.DataColumn, DataBand.Filter и DataBand.Sort
- исправлен TypeConverter на свойстве TextObject.ParagraphFormat 
- исправлена ошибка с исключением при двойном клике по текстовому объекту
- исправлена ошибка с тенью отчета в дизайнере при включенном режиме Right-to-Left
- исправлена ошибка, при которой QueryBuilder добавлял лишнюю запятую
- исправлена ошибка с добавлением лишних пробелов в QueryBuilder
- исправлена ошибка с позицией тени отчета при масштабировании в Right-to-Left дизайнере
- исправлена ошибка с невозможностью возврата и отмены действия при копировании формата

  [Preview]
+ добавлена возможность подписки на события PreviewControl.OnPrint и PreviewControl.OnExport, которые вызываются непосредственно при нажатии соответствующих кнопок
- исправлена ошибка с разрывом ManualBuild таблицы с CanBreak = false
- исправлена ошибка с отображением на предпоследней странице PageFooter с PrintOn = LastPage

  [Exports]
+ добавлена возможность экспортировать гиперссылки в RTF документы
+ добавлена возможность разделять страницы с данными в разные листы при экспорте в Excel2007
* доработан пример \Demos\C#\PrintZPL 
- исправлена ошибка с экспортом изображений в формат ZPL 
- исправлена ошибка с неправильной высотой ячеек при экспорте в Excel2007
- исправлена ошибка с экспортом пустой страницы в Excel2007
- исправлена ошибка с экспортом страницы с неправильным размером в Excel97
- исправлена ошибка с экспортом пустых ячеек в Excel2007
- исправлена ошибка с экспортом зачеркнутого текста в Excel2007
- исправлена ошибка с экспортом зачеркнутого текста в Word2007, при использовании html-тегов и условного форматирования
- исправлена позиция QR кода при экспорте в формат ZPL
- исправлен приоритет настроек страницы при экспорте в формат ZPL
- исправлена ошибка с повторной записью одинаковых изображения при экспорте в Html (с параметрами Layers, EmbeddedPictures)
- исправлена ошибка с отсутствием гиперссылок на картинках, фигурах, QR-кодах при экспорте в PDF
- исправлена ошибка с экспортом пустого текста в RTF, при использовании CanShrink = true и TextRenderType = HtmlParagraph
- исправлены ошибки RichObject - разбор RTF, списки и цвет текста

  [WebReport]
+ добавлены свойства PdfImagesOriginalResolution, PdfJpegCompression и PdfColorSpace
+ добавлен поворот страниц с альбомной ориентацией при печати из браузера
+ добавлено событие CustomAuth

  [.Net Core]
* изменена зависимость графики с CoreCompat.System.Drawing на System.Drawing.Common
- исправлена утечка памяти в PDF-экспорте
- исправлена утечка памяти в движке шрифтов
- исправлена c шириной глифов в PDF-экспорте
- исправлены ошибки построения отчёта со сложными выражениями ("Requested operation is not available because the runtime library function '' is not defined.")
- исправлено отображение шрифтов при экспорте в PDF, уменьшена точность до 2 знаков
- исправлена ошибка с неправильным отображением арабских символов
- исправлено имя шрифта для шрифтов с дополнительными весами (SemiBold, ExtraBold, Light и т.д.)
> существующий файл font.list должен быть удалён вручную - он автоматически перестроится при следующем экспорте в PDF. Полное перестроение файла font.list занимает значительное время.


Версия 2019.3
---------------
  [Engine]
+ добавлено свойство ImageAlign для выравнивания изображения внутри PictureObject; по умолчанию выравнивание отключено
+ добавлено новое свойство Config.ProcessEvents для кнопки отмены в диалоговом окне выполнения
- исправлена ошибка в AdvancedTextRenderer, приводящая к бесконечному циклу при включенной опции WordWrap и ширине объекта меньше ширины одного символа
- исправлена ошибка, когда в некоторых случаях TypeConverter-ы не загружались правильно
- исправлена ошибка, приводящая к утечке памяти в HtmlTextRenderer
- исправлена ошибка при использовании cвойства KeepTogether у группы с матрицами, когда в некоторых случаях заголовок оставался на одной странице, а матрица находилась на другой странице

  [Designer]
+ добавлена возможность изменять шрифт в редакторе запросов
+ добавлен объект цифровая подпись для размещения пустых полей для подписи PDF документов

  [Preview]
- исправлена ошибка, из-за которой зависал процесс подготовки, а кнопка отмены была неактивной на протяжении всей подготовки

  [Exports]
+ добавлена возможность экспортировать пустые поля для подписи PDF документов
+ добавлены ссылки для изображений в HTML-экспорт
- исправлена ошибка в CSV-экспорте, когда при включенной опции "Только данные", экспортировались не только Data-бэнды
- исправлена ошибка, когда PDF-экспорт не экспортировал некоторые градиенты SVGObject в PDF-файл, при свойстве GradientQuality = GradientQualityEnum.Image
- исправлена ошибка, из-за которой колонтитулы страницы не экспортировались в Word с режимом абзаца

  [WebReport]
- исправлена ошибка с унаследованными отчетами в онлайн-дизайнере
- исправлены имена сохраняемых отчётов из Онлайн Дизайнера в Core-версии

  [.Net Core]
+ добавлена ссылка на CoreCompat.System.Drawing в скрипт, что позволит использовать Color, Font и некоторые другие возможности System.Drawing


Версия 2019.2
---------------
  [Engine]
+ добавлена текстурная заливка
* теперь, в новых отчётах, шрифт по умолчанию будет всегда сериализоваться
- исправлена ошибка с методом генерации штрих-кода Supplement 5 (EAN-5)
- исправлена ошибка с неверным преобразованием типов полей в источниках данных (ВАЖНО! Данное исправление может повлиять на работу ранее разработанных отчетов)
- исправлена ошибка с неверным преобразованием Nullable типов полей
- исправлена ошибка с разбором старых отчетов (до 2016 года), когда Arial 10pt не загружался в локали jp и zh
- исправлена ошибка с удалением серий MSChartObject, когда свойство AutoSeriesColumn пусто а AutoSeriesForce имеет значение false

  [Designer]
+ добавлен пункт "Скрыть нули" в контекстное меню текстовых объектов
+ добавлена возможность выбора стиля из контекстного меню
+ добавлены диалоги при закрытии для редактора текста; теперь при нажатии кнопки "Х" будет вызван диалог для подтверждения изменений текста
+ добавлена возможность сортировать источники данных в окне данных
+ добавлена возможность сортировать поля данных в окне данных

  [Exports]
+ добавлена возможность экранирования кавычек при экспорте в CSV
+ добавлена цифровая подпись PDF
+ добавлена возможность экспортировать гиперссылки в Word2007
+ добавлена возможность экспортировать гиперссылки в Excel2007
* файлы Word2007 теперь получают верную локализацию (Res.LocaleName)
- исправлена ошибка с лишним переводом строки в экспорте Word
- исправлена ошибка с пропадающими рамками RichObject при экспорте с включенным свойством ConvertRichText
- исправлена ошибка с законцовками линий границ в экспорте PDF
- исправлена ошибка конвертирования жирного текста во встроенном RichObject при экспорте в PDF

  [WebReport]
+ добавлено свойство WebReport.PdfInteractiveForms
+ добавлено свойство WebReport.DateTimePickerFormat, которое позволяет назначить формат для DateTimePicker в WebReport
+ добавлена локализация редактируемых полей
- исправлена ошибка редактируемых полей в таблицах

  [.Net Core]
+ добавлена функция PolyLineObject.SetPolyLine(PointF[] newPoints), которая позволяет изменить набор точек
+ добавлены свойства для WebReport Core, которые позволяют включать и отключать отображение экспортов на панели инструментов
+ добавлена локализация WebReport
- исправлена ошибка с врапером roslyn, когда предупреждение поднималось как ошибка, при использовании Microsoft.CodeAnalysis версии выше 2.0
- исправлена ошибка предварительного просмотра в онлайн-дизайнере

  [Extras]
* обновлены арабские ресурсы


Версия 2019.1
---------------
  [Engine]
+ добавлено свойство FastReport.Utils.Config.PreparedCompressed (значение по умолчанию: true) для включения или выключения сжатия файлов с подготовленными отчетами (fpx)
+ добавлена возможность отключить горячие клавиши в дизайнере и предварительном просмотре
+ добавлено свойство ReportPage.Printable (значение по умолчанию: true) для включения или отключения печати страницы
* оптимизирована работа с SVG объектом, отвязан SVGObject от PictureObject, значит теперь SVG объект не рисуется в памяти для его отображения в векторных экспортах
> следует обратить внимание на работу с SVG объектом, он теперь отвязан от PictureObject, в следствии два свойства больше не доступны: Tile - которое отрисовывало SVG изображение с повторением по вертикали и горизонтали, а также Image - которое хранило отрисовываемое изображение. Отказ от последнего свойства позволил отрисовывать SVG объект в векторных экспортах без отрисовки растового изображения в памяти. Вам необходимо перепроверить ваши отчёты, если вы использовали SVG объект как наследник PictureObject.
- исправлена ошибка с большими нагрузками на движок с отчетами с использованием направляющих линий
- исправлена ошибка при разборе RTF элемента "необязательный дефис"
- исправлена ошибка, приводящая к исключению System.ArgumentOutOfRangeException в методе MSChartObject.DeleteSeries(int index)
- исправлена ошибка со значением null возвращаемым методом FastReport.Utils.Variant.ToString()
- исправлена ошибка с неиспользуемым параметром в конструкторе FastReport.Utils.FastString.FastString(int)
- исправлена ошибка, приводящая к бесконечной рекурсии в свойстве TextObject.ParagraphFormat
- исправлена ошибка, приводящая к System.IndexOutOfRangeException в методе BarcodeCodabar.GetPattern()
- исправлена ошибка с размером смещения текста при использовании TextObject.ParagraphOffset
- исправлена ошибка с печатью бэнда при отключенном свойстве Printable
- исправлена ошибка с расчетом размера объекта SVG, когда отрицательные значения используются в ViewBox
- исправлена ошибка с отрисовкой, когда текстовый объект содержал только символы табуляции
- исправлена ошибка с размером отступов при печати отчёта с использованием TextObject[TextRendererType = TextRenderType.HtmlParagraph]
- исправлена ошибка с подготовкой отчета, когда SubreportObject не имеет ссылки на страницу отчета

  [Designer]
+ добавлено сохранение последней активной вкладки окна настроек дизайнера
* улучшен алгоритм работы SubreportObject и дизайнера, теперь вы можете удалять и копировать страницу Subreport
- исправлена ошибка, при которой элементы форматирования остаются активными после удаления объекта
- исправлена ошибка сохранения sql-запроса по нажатию кнопки "Готово"
- исправлена ошибка при копировании Диалоговой Страницы (DialogPage) приводящая к исключению System.NullReferenceException
- исправлена ошибка с активными кнопками группы Отчет->Бэнды (Report->Bands) при редактировании диалоговой страницы (DialogPage)
- исправлена ошибка с активными кнопками "Сетка", "Направляющие линии", "Авто-направляющие", "Удалить горизонтальные направляющие" и "Удалить вертикальные направляющие" при редактировании диалоговой страницы
- исправлен порядок объектов в панели инструментов
- исправлена ошибка с неверной позицией немаксимизированного окна (окно не отображается) при отключенном втором мониторе
- исправлена ошибка, приводящая к утечке памяти при подключении к CSV
- исправлена ошибка с пустым условием заголовка группы
- исправлена ошибка, приводящая к System.ArgumentException в Редакторе Диаграмм (Chart Editor) при ширине полосы меньше нуля
- исправлена ошибка, приводящая к System.ArgumentException в Редакторе Диаграмм (Chart Editor) при шаге маркеров меньше одного

  [Preview]
+ добавлена возможность простой печати из консоли с использованием команды `Viewer.exe /P`
* теперь, настройки двусторонней печати (Duplex) меняются в окне Печати при их изменении в настройках принтера
- исправлен размер иконок при использовании <dpiAware>true</dpiAware>
- исправлена ошибка с отображением grayscale SVG

  [Exports]
* улучшена упаковка шрифтов в pdf экспорте, при использовании простых лигатур (fi, tt)
* улучшена эмуляция стиля шрифта в pdf
- исправлено отображение текста в экспорте pdf в системах linux, когда текст начинается со знака табуляции
- исправлен пропущенный тег "</html>" в HTML экспорте с одной страницей
- исправлена ошибка с экспортом pdf, когда формат чисел по умолчанию символичен, а не цифровой
- исправлен экспорт в Word 2007; теперь текстовые объекты и ячейки таблицы с пустой строкой и свойством TextRenderer = Default могут быть отредактированы 

  [Demos]
+ добавлен демо проект, как использовать FastReport в контейнере docker CentOS
- исправлена ошибка, приводящая к долгому показу сообщения "Печатается страница N" в FastReport.NET Demo

  [.Net Core]
* удален api диалогов из версии для .Net Core
- исправлен перенос пустых пробелов на новую строку
- исправлена ошибка с врапером roslyn, когда предупреждение поднималось как ошибка

  [Extras]
* обновлен json-коннектор для работы с последней версией
* обновлена греческая локализация

Версия 2018.4
---------------
  [Engine]
+ добавлена возможность обращаться к итогам, параметрам и переменным без чувствительности к регистру
+ добавлена новая экспериментальная возможность по улучшению работы с памятью
> мы постоянно пытаемся улучшить производительность и работу с памятью FastReport.Net, в данный момент мы добавили новое экспериментальное свойство Config.IsStringOptimization, которое позволяет использовать строки из пула строк при загрузке очень больших отчётов fpx. Для включения этой возможности просто измените значение IsStringOptimization в истину. Пока это свойство экспериментальное, изменить его можно только с помощью кода. Особенно это свойство будет интересно пользователям, которые используют не менее 1 000 000 объектов в отчёте.
* переписан парсер RTF текста - вложенный документ разбивается на объекты TextObject, TableObject, PictureObject при включенном режиме "ConvertRichText"  
* теперь целочисленное деление на ноль не приводит к сбою генератора, вместо этого выражение содержащее ошибку будет заменено текстом «DIVISION BY ZERO!»
* оптимизирована отрисовка объекта QR Code Barcode
- исправлена трансляция переноса строки в результате выражения в объекте Richtext 
- исправлен алгоритм обработки выражений в RichObject
- исправлена ошибка с форматированием внутри выражения объекта RichText
- исправлена ошибка с кодировкой символа ";" в баркоде Code128
- исправлена ошибка с поворотом баркодов
- исправлена ошибка, когда в некоторых случаях изображения при экспорте в PDF были выше чем нужно
- исправлена ошибка печати текстовых объектов при заданном свойстве TextRenderType = HtmlParagraph
- исправлена ошибка, при которой большое количество текста в ячейке приводит к бесконечной генерации пустых страниц в отчете
> ВНИМАНИЕ !!! Мы уменьшили значение по умолчанию свойства MaxHeight с 5000 до 1000, для объекта TableRow. Вам необходимо проверить свои отчёты, если вы использовали строки в таблице высотой больше 20см!!!
- исправлена ошибка  "An item with the same key has already been added"  в методе AssemblyDescriptor.Compile()
- исправлена ошибка в MSChartObject с AutoSeries в детальных отчетах
- исправлен разбор многостраничного текста в RichObject
- исправлена ошибка переключения режимов SVG-объекта "SVGObject.Grayscale = true -> SVGObject.Grayscale = false", при которой объект оставался чёрно-белым
- исправлена ошибка с положением SubreportObject на странице с бесконечной шириной

  [Designer]
+ теперь в окне просмотра данных отображаются номера строк, показанных на странице
+ добавлена возможность изменять размер бэнда перетаскивая его за верхнюю часть, при этом объекты перемещаются в пределах бэнда
+ добавлена возможность копировать страницы отчета в дизайнере
+ добавлены фильтры "Текстовый файл (*.txt)" и "Все файлы (*.*)" в окне подключения к CSV таблице
+ добавлено свойство Hyperlink.OpenLinkInNewTab
* кнопки в окне просмотра данных неактивны, когда размеры окна не позволяют вместить хотя бы одну строку
* теперь кнопки в Дереве Данных становятся неактивными, когда дерево теряет фокус
- исправлена ошибка с вводом польского символа "ą" (правый Alt + "A") в текстовом редакторе
- исправлена редкая ошибка, когда при увеличении окна просмотра данных отображаются не все строки, хотя места достаточно
- исправлена ошибка с сохранением файла в неправильную папку в диалоге Сохранить Как
- исправлена ошибка с расширением файла в окне Сохранить Как, когда отчет получен конвертированием из файла, который не является файлом FastReport .NET
- исправлена ошибка с некорректным перемещением объектов когда мышь двигается слишком быстро при изменении размера бэнда за его верхнюю часть
- исправлена ошибка с возникновением исключения System.NullReferenceException после закрытия вкладки Start Page в MDI дизайнере
- исправлена ошибка с возникновением исключения System.ArgumentException когда имя файла содержит точку "." при подключении к CSV таблице
- исправлена ошибка с одинаковыми именами полей в подключении к CSV таблице, когда имена полей хранятся в первой строке файла
- исправлена ошибка с потерей фокуса редактора событий объекта после вызова предварительного просмотра отчета
- исправлена ошибка с видимостью свойств Left, Top и Width у DataBand
- исправлена ошибка с возникновением исключения System.OverflowException в DesignerControl при загрузке отчета, содержащего страницу с бесконечной шириной
- исправлена ошибка с некорректным добавлением нового объекта, если свойство выбранного объекта изменилось

  [Preview]
+ добавлена возможность копирования и удаления подготовленных страниц в предварительном просмотре

  [Exports]
+ добавлено свойство HTMLExport.EnableVectorObjects (включено по умолчанию)
+ добавлено новое свойство для баркода AsBitmap которое форсировано будет использовать растровое изображение вместо векторного, по умолчанию свойство будет равно False, что означает экспорт как вектор
+ добавлено свойство в пользовательский интерфейс Word2007Export DoNotExpandShiftReturn, позволяющие регулировать горизонтальное выравнивание для мягких переносов
+ добавлено свойство Excel2007Export.PrintFit в экспорт в Excel 2007 (может принимать значения: NoScaling, FitSheetOnOnePage, FitAllColumsOnOnePage, FitAllRowsOnOnePage)
+ добавлена прямая трансляция RichObject в экспорт DOCX в режимах Layered и Paragraph
* переработано меню экспортов, теперь экспорты сгруппированы по категориям
* обновлен экспорт в FR3 (файлы FastReport VCL), добавлен экспорт таблиц, баркодов, карт и геометрических фигур
* увеличенная точность для SVG в высоком разрешении при экспорте в PDF
- исправлена ошибка с отрицательными шириной или высотой изображения при экспорте в HTML и в WebReport
- исправлены динамический поворот, отступы и размеры страницы в табличном и послойном экспортах MS Word 2007
- исправлена утечка памяти при использовании баркодов в экспорте PDF, HTML
- исправлена ошибка с неверной позицией баркода внутри TableCell при экспорте в PDF, HTML, SVG
- исправлена ошибка с неверными именами файлов в HTML экспорте при включенном свойстве Subfolder
- исправлена ошибка с одной картинкой в экспорте в Excel 2003 (BIFF8, xls) и в Excel 2007 (xlsx)
- исправлена ошибка с прозрачным фоном картинок в Excel 2007 (xlsx)
- исправлен режим "Текст в кривых" в экспорте PDF
- исправлена симуляция отсутствующих стилей шрифтов в PDF экспорте
- переработана подсистема встраивания шрифтов, добавлена проверка лицензии шрифта на разрешение его встраивания и/или упаковки
- исправлена ошибка с рисованием рамки таблицы при экспорте в PDF при установленных свойствах Layout = Wrapped, FixedColumns = 1 и динамическим количеством столбцов
- исправлена ошибка с отступами (paddings) в экспорте в Excel 2007 (xlsx)
- исправлена ошибка с открытием файла экспорта в Excel 2007 при установленном свойстве ParagraphOffset
- исправлена ошибка с экспортом изображений в Excel 2003 (BIFF8, xls)
- исправлена конвертация вещественных чисел в персидской локализации
- исправлено свойство экспорта в PDF SvgAsPicture, когда баркоды экспортировались как SVG а не как изображения
- исправлена ошибка с экспортом BarcodeObject с использованием свойства Padding при его конвертации в SVG
- исправлена ошибка с некорректным экспортом \ в гиперссылках в PDF
- исправлена ошибка "null reference exception" в ImageExport, возникающая, если Watermark.Text равен null
- исправлена ошибка с прозрачностью Watermark в экспорте в PDF
- исправлена ошибка с очень широкими документами в экспорте в Excel 2007
- исправлена ошибка с "слишком жирным" жирным шрифтом в PDF экспорте
- исправлена ошибка с экспортом некоторых символов в Excel2007Export

  [.Net Core]
+ добавлен пакет FastReport.Data.OracleODPCore в репозиторий Nuget (https://www.nuget.org/profiles/FastReports)
- исправлена ошибка, когда иногда пробельные символы в конце строки переносились на новую строку
- исправлена ошибка сохранения из онлайн-дизайнера в FastReprot.Web.Core по протоколу https
- исправлена ошибка, при которой экспорт Core был неправильным
- исправлена ошибка с испорченными символами «новой строки» в онлайн-дизайнере
- исправлено формирование названий типов данных для .Net Core

  [WebReport]
+ добавлен пример Demos/C#/Web/PreparedPreview/ который демонстрирует показ предварительно подготовленного отчета в Web
+ добавлен метод WebReport.LoadFromFile(string fileName), который загружает отчет из файла
+ добавлен метод WebReport.LoadFromStream(Stream stream), который загружает отчет из потока
+ добавлен метод WebReport.LoadPrepared(string fileName), который загружает подготовленный отчет из файла
+ добавлен метод WebReport.LoadPrepared(Stream stream), который загружает подготовленный отчет из потока
+ добавлен конструктор WebReport(bool inlineRegistration), который выполняет быструю инициализацию контрола без необходимости предварительной загрузки служебных скриптов и стилей
+ добавлен конструктор WebReport(bool inlineRegistration, bool stretched), который выполняет быструю инициализацию с установкой ширины и высоты контрола в 100%
+ добавлено свойство WebReport.XlsxPrintFitPage для включения масштабирования Excel 2007 листа на страницу при печати 
- исправлена ошибка с проверкой handlers в файле Web.config
- исправлена ошибка с сохранением отчета с Referenced Assemblies в Online Designer из браузера Firefox
- исправлена ошибка с отображением баркодов в Internet Explorer 8 и более старых версий

  [Extras]
- исправлена ошибка с параметрами ActiveQueryBuilder
- исправлена ошибка пакета FastReport.Data.Json связанная с расположением библиотеки Newtonsoft.Json.dll  
- исправлена ошибка с кавычками в запросах, которые содержат название схемы в пакете FastReport.Data.Postgres; теперь в дизайнере доступны таблицы не только из схемы public

  [Online Designer]
+ добавлено свойство Hyperlink.OpenLinkInNewTab для открытия ссылок в новой вкладке
- HtmlTags заменён на TextRendererType
- исправлена ошибка с контролем наличия пробелов в именах объектов

Версия 2018.3
---------------
  [Engine]
* переписан код подстановки выражений в RichObject
+ добавлена печать бесконечных страниц на рулонных принтерах (свойство ReportPage.PrintOnRollPaper)
- исправлен расчёт размера изображения при повороте SVG объекта
* свойство HtmlTags текстового объекта было отмечено как устаревшее, добавлено новое свойство TextRenderType.
> замечание разработчика: свойство HtmlTags позволяло использовать некоторые HTML теги в тексте TextObject, один из доступных тегов тег FONT, этот тег является устаревшим, и не все браузеры адекватно поддерживают его, поэтому мы добавили новый обработчик визуализации, который позволяет использовать некоторые стили CSS, в атрибуте style и тег span.
+ добавлено новое свойство ParagraphFormat для форматирования параграфов в текстовом объекте только при значении HtmlParagraph в свойстве TextRenderType. Это свойство позволяет регулировать межстрочный интервал и красную строку.
* новый обработчик текста поддерживает следующие теги: b, i, u, strike, br, sub, sup, img, span.
> замечание разработчика: Мы не стремимся сделать копию браузера в текстовом объекте, однако пытаемся сделать логику максимально похожей, но с ограничениями, тег img поддерживает только атрибут src (http, https, base64) и атрибуты width и height(значения в пикселях), теги b, i, u, strike, sub, sup и span поддерживают только атрибут style, с минимальным набором стилей.
+ добавлен новый механизм конвертирования объектов перед экспортом, процесс происходит автоматически, это необходимо для преобразования некоторых объектов в векторную графику.
- исправлена отрисовка подстрочного и надстрочного индекса для нового типа визуализатора текста HtmlParagraph, когда в некоторых случаях неправильно рассчитывался размер и расположение текста.
+ теперь при экспорте объект Barcode преобразуется в векторную графику для PDF, HTML и SVG экспортов
- исправлена ошибка с svg,содержащими "DOCTYPE svg PUBLIC" в SVG-объекте
- исправлена ошибка с [COPYNAME#] в водяном знаке страницы
- исправлено название свойств TextObject, где использовалось слово Multiply вместо Multiple

  [Designer]
+ добавлена возможность задать язык скрипта по умолчанию
- исправлена ошибка с выбором языка скрипта по умолчанию при первом запуске дизайнера
- исправлена редкая ошибка когда таблица не отображается в окне Просмотр Данных
- исправлена ошибка в окне Просмотр Данных при количестве столбцов более 655
+ добавлен редактор столбцов в свойства и во всплывающее меню DataBand

  [Preview]
+ добавлена возможность отключить сохранение подготовленного отчета в предварительном просмотре (PreviewExports.Prepared элемент)
- исправлена ошибка когда все экспорты должны быть отключены в предварительном просмотре (PreviewControl.PreviewExports == PreviewExports.None) но Excel 97, ZPL и LaTeX экспорты доступны
* улучшен метод кэширования изображения SVG объекта
+ добавлено свойство SaveInitialDirectory (Config.PreviewSettings.SaveInitialDirectory = @"C:\user\initial_directory";)

  [Exports]
- теперь SVGObject экспортируется как SVG в HTML
- исправлена ошибка с разрешением экрана в экспорте в Word 2007
- исправлена ошибка с форматированием параграфов в экспорте в Word 2007
* улучшен экспорт в Word 2007 по параграфам
* уменьшен размер файла Word 2007 (дублированные изображения не сохраняются)
- исправлена ошибка с неверной установкой размеров "Unlimited" страницы в экспорте в Word 2007
+ теперь объект SVG экспортируется как векторная графика в PDF
+ добавлена новая вкладка «Векторная графика» для экспорта pdf, вы можете установить качество градиентов, интерполяцию градиентов и интерполяцию кривых для SVG объекта и шрифтов в кривых
* в экспорте по параграфам в Word 2007 документ сохраняется без разбиения на страницы 
* добавлено преобразование в Числовой формат для экспорта в Excel2007(*.xlsx)
- исправлена ошибка с именами полей в DBF экспорте
+ добавлен Text Object при TextRenderType = HtmlParagraph в pdf, html, word2007 экспорты
+ добавлены свойства Word2007Export.PrintOptimized и Excel2007Export.PrintOptimized
+ добавлены чекбоксы "Для печати" в диалоги Word 2007 и Excel 2007
- исправлена ошибка с перекрытием текстовых заголовков в диалоге экспорта SVG
+ добавлено свойство FontScale в Excel2007-экспорт

  [WebReport]
+ добавлен SVG-объект в WebReport как svg-изображение
- исправлена ошибка с третьим и более drill-down с использованием детальных страниц
- исправлена ошибка с неверным URL в drill-down
+ добавлены свойства WebReport.DocxPrintOptimized и WebReport.XlsxPrintOptimized

  [.Net Core]
+ добавлен SVG-объект (SVGObject)
+ добавлен пакет FastReport.Data.MsSql в репозиторий Nuget (https://www.nuget.org/profiles/FastReports)
+ добавлен пакет FastReport.Data.MySql в репозиторий Nuget (https://www.nuget.org/profiles/FastReports)
+ добавлен пакет FastReport.Data.Postgres в репозиторий Nuget (https://www.nuget.org/profiles/FastReports)
+ добавлен пакет FastReport.Data.SQLite в репозиторий Nuget (https://www.nuget.org/profiles/FastReports)
+ добавлен пакет FastReport.Data.Json в репозиторий Nuget (https://www.nuget.org/profiles/FastReports)
+ добавлен пакет FastReport.Data.MongoDB в репозиторий Nuget (https://www.nuget.org/profiles/FastReports)
+ добавлен пакет FastReport.Data.RavenDB в репозиторий Nuget (https://www.nuget.org/profiles/FastReports)
+ добавлен пакет FastReport.Data.Couchbase в репозиторий Nuget (https://www.nuget.org/profiles/FastReports)
- исправлена ошибка с экспортом в Word 2007 в некоторых случаях
- исправлена ошибка с отсутствием изображений в Excel 2007
* добавлена совместимость с macOS
- исправлена ошибка с drill-downs в WebReport Core

  [Extras]
+ добавлен редактор TeeChart объектов (двойной щелчок по объекту TeeChart)
- исправлена ошибка с некоторыми строковыми значениями при подключении источника данных к TeeChart объекту
- убрана возможность выбрать для свойств LabelField, XValuesField и YValuesField поля из источников данных, к которым TeeChart объект не подключен
* улучшен плагин ActiveQueryBuilder (https://www.activequerybuilder.com/): теперь он отображает схему базы данных и предоставляет параметры запросов

  [Demos]
* в демонстрационном отчёте полигонов заменены звёздочки на красивые

  [Resources]
* обновлены французские ресурсы

  [Online Designer]
+ добавлена возможность смены языка на вкладке view
+ все запросы отправляются с параметров same-origin
- исправлены аббревиатуры некоторых языков 

Версия 2018.2
---------------
  [Engine]
+ добавлена совместимость с Fips Algorithm Policy (ограничения: шифрование PDF экспорта, шифрование отчета)
+ объект SVGObject добавлен в основную библиотеку FastReport.dll (для .Net 4 и выше, в Core-версии в данный момент не поддерживается)

  [.Net Core]
+ добавлены демонстрационные пакеты в репозиторий Nuget (https://www.nuget.org/profiles/FastReports)
- исправлена ошибка установки пакетов

  [Designer]
+ добавлен индикатор события для объектов и бэндов, маленький треугольник в верхнем левом углу; эта функция может быть включена или отключена в настройках дизайнера (по умолчанию отключена)
+ добавлена новая вкладка настроек дизайнера: "Внешний вид объектов"
- исправлен импорт из формата rdl 2010

  [Exports]
+ добавлено свойство RichTextObject.ConvertRichText для преобразования RichText в текстовые объекты при экспорте (experimental)
+ добавлен экспорт в Word 2007 по параграфам (experimental), свойство Word2007Export.ParagraphBased
* увеличена скорость экспорта в CSV
* увеличена скорость экспорта в PDF
- исправлена ошибка с удалением последнего символа в каждой строке при экспорте в CSV без разделителя
- исправлена ошибка с текстовыми ресурсами в экспорте FTP
- исправлена ошибка с отображением латинских символов в полях ввода в интерактивных PDF в браузере Chrome
- исправлена ошибка с большим размером PDF файлов
- исправлена ошибка с прозрачным фоном ячеек в экспорте в Excel 2007
- исправлена ошибка с линиями и графическими объектами в послойном экспорте в Word 2007
- исправлена ошибка с чекбоксами в послойном экспорте в Word 2007
- исправлена ошибка со значением по умолчанию свойства Word2007Export.Wysiwyg
- исправлена ошибка с открытием экспортированных файлов в Excel 2007
- исправлена ошибка с медленным экспортом отчетов с бесконечной шириной или высотой

  [WebReport]
+ добавлена поддержка редактирования объектов TextObject и CheckBoxObject
+ добавлены свойства WebReport.DocxWysiwyg, WebReport.DocxParagraphBased
- исправлена позиция индикатора загрузки
- исправлена ошибка с null указателем в сервисном javascript коде

  [Extras]
+ добавлен плагин Steema TeeChart (\Extras\Misc\TeeChartObjectPlugin) https://www.steema.com/
+ добавлен новый пример \Demos\C#\PrintZPL

  [Online Designer]
+ добавлена возможность горизонтального ресайза бэндов
+ добавлены нотификации online/offline
+ добавлена offline работа дизайнера с service workers
+ добавлено свойство Editable для текстовых объектов и чекбоксов
+ добавлен компонент SimpleProgressGauge
* изменен стиль tooltips при перемещении компонент 
- исправлена ошибка с добавлением компонент на диалоговую страницу
- исправлена ошибка с неверной отрисовкой линии ресайза бэнда
- исправлена ошибка с неверным выбором DataSource для DataBand при сохранении отчета


Версия 2018.1
---------------
  [.Net Core]
+ добавлен WebReport для .Net Core (FastReport.Web.Core\README.md)
+ добавлена поддержка Online Designer

  [Preview]
+ добавлена возможность изменения объектов TextObject, CheckBoxObject в предварительном просмотре (при включенном свойстве Editable)
- исправлен неработающий поиск в окне предварительного просмотра

  [Engine]
+ добавлено свойство Editable для объектов TextObject и CheckBoxObject
- исправлена ошибка при инициализации параметра с типом double целочисленным значением

  [Дизайнер]
+ добавлены редакторы датчиков, полукруглые датчики, добавлена возможность градиентной заливки указателя
* увеличена скорость генерации больших отчетов с опцией UseFileCache
* улучшено поведение при выборе объекта "Линия" при масштабе > 100%
- исправлена ошибка с обработкой события мыши на панелях инструментов PolyLineObject и PolygonObject

  [Экспорты]
+ добавлены интерактивные (заполняемые) формы в экспорте PDF, объекты с включенным свойством Editable будут экспортироваться как поле ввода
+ добавлен экспорт в формат ZPL (Zebra printers)
+ добавлено сохранение многоугольников и ломаных линий в экспорт в PowerPoint
+ добавлено свойство ShiftNonExportable указывающее, что бэнды отчёта должны быть смещены вверх, если для какого-либо бэнда установлено свойство Exportable = false
+ добавлены свойства в SVG-экспорт: PreserveAspectRatio, UseWidthAndHeight и UseViewBox
- исправлена ошибка экспорта в несколько файлов в SVG экспорте
- теги width и height заменены на ViewBox в экспорте в SVG
- исправлена ошибка многократного экспорта из одного экземпляра класса
- исправлена ошибка при экспортировании отчета из кода при Report.MaxPages равным 1 или больше
- исправлена ошибка экспорта отчётов с таблицами в файлы изображений
- исправлена ошибка экспорта в Excel2007 объектов с ссылками, содержащими амперсанд (&)
- исправлена ошибка экспорта в Word2007 (отображение чёрных страниц при просмотре через OpenOffice)

  [WebReport]
+ добавлено отображение оглавления отчета в WebReport
- исправлена ошибка, когда обработчик (handler) находится в 'location' тегах

  [Extras]
- исправлена ошибка кодировки в json-коннекторе, добавлено свойство DataEncoding

  [Online Designer]
+ добавлена возможность на этапе сборки спрятать кнопку preview
+ добавлен SVGObject
+ группировка однотипных компонентов (Gauge etc.) на вкладке components
+ текст ошибки с сервера при сохранении отчета теперь открывается в диаложке
* info (i) показывается в диаложке вместо попапа в правом верхнем углу
- обновлены значения свойства Cursor
- исправлена ошибка с выбором цвета из тулбара в браузере IE
- исправлена ошибка с полем для выбора цвета в Highlight редакторе и Border редакторе в браузере IE
- исправлена ошибка, связанная с тем, что панель properties была пустой для TableColumn и TableRow
- исправлена ошибка, связанная с отображением бендов в неправильном порядке в браузере Chrome


Версия 2017.4
---------------
  [Core]
+ добавлена поддержка .Net Core в редациях Professional и Enterprise (\Demos\Core\FastReportCore.MVC\readme.txt)

  [Engine]
+ добавлено свойство Trim для линейных штрих-кодов
+ добавлено свойство Tag для всех компонентов
+ добавлено сохранение мета-данных (ReportInfo.Name, ReportInfo.Author, ReportInfo.Description, 
  ReportInfo.Created, ReportInfo.Modified, ReportInfo.CreatorVersion) в файл готового отчета
+ добавлены функции RegisterData(DataSet data, bool enableAllTables) и RegisterData(DataSet data, string name, bool enableAllTables)
  для регистрации DataSet и активации всех его таблиц
+ добавлена возможность обращаться к Report.Dictionary без чувствительности к регистру
+ добавлен круговой датчик (RadialGauge)
+ добавлен простой датчик прогресса (SimpleProgressGauge)
- исправлена ошибка вывода неверных результатов для значений типа n.9999 в функциях NumToWords
- исправлена ошибка с многопоточным построением и использованием курсоров в отчете
- исправлены границы объектов типа датчик (Gauge)
- исправлены пропорции шкалы и указателя простого датчика (SimpleGauge)

  [Дизайнер]
+ добавлен постраничный вывод в окне просмотра данных
+ добавлен Пробел в список разделителей в подключении к CSV таблице
+ добавлена возможность открывать файлы List and Label с расширениями crd, srt, inv, lab и let
+ добавлен выбор предыдущего фильтра в окне открытия файла
- исправлена ошибка с удалением бэндов при определенной последовательности действий
- исправлена ошибка с пустыми полями при подключении к CSV таблице
- исправлена ошибка с пробелом в качестве разделителя при подключении к CSV таблице
- исправлена ошибка со строками без разделителей при подключении к CSV таблице
- исправлена ошибка при просмотре данных бизнес-объекта
- исправлена ошибка со значением System.Guid равным null
- исправлена ошибка в классе PageColumns когда количество позиций не равно количеству колонок

  [Экспорты]
+ добавлен экспорт в LaTeX (без изображений, поддерживается XeLaTeX)
* добавлено свойство Word2007Export.RowHeight с множеством (Minimum, Exactly)
* добавлено преобразование в процентный формат для экспорта в Excel2007(*.xlsx)
- исправлена ошибка с дубликатами баркодов в PDF экспорте
- исправлена ошибка дублирования ячеек таблиц в экспортах в XAML и SVG
- исправлена ошибка экспорта символа тильда (~) в экспорте в Excel2007
- исправлена ошибка дублирования изображений в PDF экспорте
- исправлена ошибка экспорта Biff8 из подготовленного отчёта
- добавлена возможность экспортировать текстовые объекты с нестандартным значением параметра FontWithRatio в Excel 2007

  [WebReport]
+ добавлено свойство WebReport.DesignerConfig для хранения пользовательского конфигурационного файла для Online Designer
- исправлено изменение размеров объекта WebReport

  [Extras]
+ добавлен пример Web API self-hosted (Demos\C#\Web\WebApiSelfHosted)
+ добавлен плагин объекта SVG (SVGObject, \Extras\Misc\SVGObjectPlugin)
+ добавлен плагин для отправки отчетов с помощью Telegram (\Extras\Misc\Messaging\TelegramMessenger)
* улучшен конвертор из Crystal Reports, теперь работает и с последними версиями Crystal

  [Online Designer]
+ добавлен Highlight редактор
+ добавлена область за которую можно ресайзить левый SideBar
+ добавлены MaxiCode & Intelligent Mail баркоды
+ возможность вызывать управляющие диалоги из панели properties кликом по кнопке в заголовке подраздела
+ переключатель сразу всех панелей кастомизации
+ диалог редактирования шрифта
+ диалог редактирования border свойства
+ диалог редактирования hyperlink свойства
+ изменен механизм сборки
* изменен дизайн всплывающих сообщений в правом верхнем углу
- исправлен баг из-за которого DataHeader Band позиционировался после DataBand
- исправлен баг с зависанием на этапе загрузки в IE


Версия 2017.3
---------------
  [Engine]
+ добавлен баркод Intelligent Mail (USPS)
+ добавлен баркод MaxiCode
+ добавлено свойство Report.ReportInfo.Tag
+ добавлено свойство Report.ReportInfo.SaveMode
+ добавлена поддержка функций с необязательными параметрами
* реализована поддержка потокобезопасных коллекций для .Net 4

  [Designer]
+ добавлена возможность многострочного редактирования свойств Report.ReportInfo.Description и Report.ReportInfo.Tag
- исправлена ошибка с неверной шириной разных линий рамки

  [Экспорты]
+ добавлена возможность присоединения файлов к экспорту в формате PDF с помощью методов: PDFExport.AddEmbeddedXML, PDFExport.AddEmbeddedFile
- исправлена ошибка создания пустой страницы после таблиц в экспортах RTF и Word2007
- исправлена ошибка неправильной работы свойства Exportable у бэндов
- исправлена ошибка отображения дат в экспорте в Excel2007
- исправлена ошибка с отступами и высотой строки в PDF экспорте
- исправлена ошибка с черными прямоугольниками в экспортах

  [Extras]
+ добавлен новый пример работы с ZUGFeRD и PDF/A-3b \Demos\C#\ZUGFeRD 
+ добавлен новый пример работы с Web API \Demos\C#\Web\WebApi  
- исправлена ошибка с относительным путем к файлу JSON в JSON коннекторе

  [WebReport]
+ добавлены свойства WebReport.RequestHeaders, WebReport.ResponseHeaders
+ добавлена обработка ошибок при вызове WebReport.DesignerSaveCallBack
- исправлены отступы страниц при печати из браузера
- исправлена ошибка с линиями в HTML экспорте и WebReport
- исправлена обработка ошибок TTF для экспорта в PDF

  [Online Designer]
+ добавлена поддержка свойства ReportInfo.Tag у объекта Report
- исправлено многоуровневое отображение дочерних связей
- свойство Padding может содержать только целочисленные значения


Версия 2017.2
---------------
  [Engine]
+ добавлен новый штрихкод: Фармакод
+ добавлено новое свойство для изображений: Черно-белый(Grayscale) режим отображения
+ добавлена возможность изменения цвета штрихкодов
+ добавлено кеширование скомпилированного скрипта отчета
- исправлена ошибка с потерей точности в итогах
- исправлена ошибка с включением ReportPage.UnlimitedHeight и ReportPage.PrintOnPreviousPage
- исправлена ошибка инициализации объекта со значением null для текстовых объектов
- исправлена ошибка десериализации при сохранении из On-line Designer

  [Designer]
+ добавлена поддержка Rigth-to-Left Interface (RTL)
+ добавлено новое свойство у объекта MSChartObject, которое позволяет использовать несколько серий с автоматическим созданием
- исправлена ошибка когда вместо создания нового источника данных открывалось редактирование существующего

  [Preview]
+ добавлена поддержка Rigth-to-Left Interface (RTL)
+ добавлено масштабирование документа относительно положения мыши

  [Экспорты]
+ добавлен экспорт в Excel 97-2003 (BIFF8)
+ добавлена возможность вставки изображений в оригинальном разрешении при экспорте в PDF
+ в окне PDF экспорта добавлена возможность выбора цветового пространства
* улучшено качество изображений в экспорте в Excel 2007
* изменена работа экспорта в Dropbox для использования API 2.0 вместо API 1.0
* добавлено преобразование в формат Дата для экспорта в Excel2007(*.xlsx)
* улучшен экспорт SVG: добавлено встраивание изображений в файл, добавлена опция HasMultipleFiles, улучшено отображение текста, повёрнутого текста, добавлено подчёркивание(underlines)
- исправлена ошибка с пустыми страницами в экспорте в Excel 2007
- исправлена ошибка в PDF и HTML экспортах с вертикальной позицией текста, высота которого больше высоты объекта
- исправлена ошибка сохранения изображений в формате Metafile в RTF-экспорте
- исправлена ошибка с Vertical Alignment = bottom в  экспорте в PDF
- исправлена ошибка прозрачных изображений в экспорте XPS
- исправлена ошибка экспорта пустых изображений в формат XPS
- исправлена ошибка в предпросмотре экспорта CSV при небольшом количестве строк
- исправлена ошибка жирных японских шрифтов в экспорте в PDF
- исправлена ошибка свойства Exportable

  [Extras]
+ добавлен коннектор RavenDB \Extras\Connections\FastReport.RavenDB
+ добавлен коннектор SQL Anywhere \Extras\Connections\FastReport.SqlAnywhere
+ добавлены новые демонстрационные отчеты: Pharmacode, Box

  [WebReport]
+ добавлен вид фона тулбара ToolbarBackgroundStyle.None (вы можете использовать цвет WebReport.ToolbarColor вместо изображения из стиля)
+ добавлены свойства WebReport.UnlimitedWidth, WebReport.UnlimitedHeight для включения неограниченных размеров для всех страниц отчета (по умолчанию: false - используются настройки отчета)
+ добавлено свойство WebReport.Dialogs для включения или выключения показа диалогов отчета (по умолчанию: true - включены)
- исправлена ошибка с обработкой события onClick в WebReport
- исправлена ошибка со свойством объектов Exportable = false в предпросмотре и печати WebReport


Версия 2017.1
---------------
  [Engine]
+ добавлена возможность установить путь (URL) к изображению в PictureObject из источника данных
* доработан GS1-128 штрих-код для поддержки буквенно-числовых значений
* уменьшено потребление памяти
- исправлена ошибка с разбиением RichObject

  [Designer]
+ добавлена возможность выбора всех таблиц в DataWizardForm
+ добавлен коннектор к CSV таблицам
- исправлена ошибка с обновлением скрипта при загрузке другого отчета
- исправлена ошибка с изменением TextObject.Format
- исправлена ошибка с изменением TextObject.Border
- исправлена ошибка с отсутствующим плагином Connection

  [Preview]
+ добавлены свойства "Exports" и "Clouds" в PreviewControl для сокрытия неиспользуемых опций сохранения

  [Экспорты]
+ добавлена возможность экспорта текста в кривых в PostScript и PPML
+ добавлено свойство FastCloudStorageClient.ReportUrl содержащее ссылку на отчет после его загрузки в FastReport Cloud
+ добавлена возможность отправки отчетов посредством протокола XMPP/Jabber и FastReport Cloud
+ добавлен PDF/X-4 стандарт
+ добавлен цветовой профиль CMYK в PDF экспорт
+ добавлено новое свойство HTMLExport.EnableMargins для включения отступов страниц (по умолчанию: false)
* добавлена возможность использования изображений в XAML-экспорте в поток путём использования метода GetImage(..), свойство ToMultipleFiles заменено на HasMultipleFiles
- исправлена ошибка с экспортом GroupHeader и GroupFooter бэндов в *.FR3 экспорте
- исправлена ошибка экспорта изображений в метафайл
- исправлены ошибки форматирования документа OpenOffice Writer (Open Document Text)
- исправлены ошибки форматирования документа Word 2007 (docx)
- исправлена ошибка со шрифтом "Meiryo UI" в PDF экспорте
- исправлена ошибка с экспортом даты для немецкого языка в Excel2007 экспорте

  [WebReport]
+ добавлено свойство WebReport.ShowBackButton для отображения кнопки возврата на предыдущий отчет (закладку с отчетом)
+ добавлено новое свойство WebReport.LogFile для ведения журнала ошибок, может использоваться совместно с WebReport.Debug 
+ добавлено новое свойство WebReport.EnableMargins для включения отступов страниц (по умолчанию: false)
+ добавлено отображение фона страницы Page.Fill в WebReport
+ добавлено изменение цвета фона объекта WebReport.BackColor (по умолчанию: White)
* изменена картинка прогресса
- исправлена ошибка с печатью из браузера отчетов со ссылками на детальные отчеты
- исправлена ошибка с показом полос прокрутки при ширине и высоте равной 100% 
- исправлена ошибка с визуализацией отчетов содержащих страницы с неограниченной высотой/шириной
- исправлена ошибка с масштабами "По ширине/Страница" в тулбаре
- исправлена ошибка с многопоточностью
- исправлена ошибка TextObject.ParagraphOffset

  [Примеры]
+ добавлен новый пример \Demos\C#\WPFViewer 

  [Extras]
+ добавлен коннектор MongoDB \Extras\Connections\FastReport.MongoDB   
+ добавлен коннектор NosDB \Extras\Connections\FastReport.NosDB 
- исправлена ошибка с отображением списка таблиц в FastReport.MySQL


Версия 2016.4
---------------
  [Engine]
+ добавлен новый объект HtmlObject для использования в WebReport или экспорте в HTML
+ добавлено событие Report.CustomCalc для ручной обработки входных данных
- исправлена проблема с некорректной загрузкой сборок в скрипте отчёта

  [Designer]
+ добавлен редактор TextOutline
- исправлена ошибка с пропаданием объекта PolyLineObject, PolygonObject при вызове предварительного просмотра

  [Экспорты]
+ добавлена совместимость со стандартом PDF/X-3 в PDF экспорте 
+ добавлено новое свойство PDFExport.PDFCompliance 
+ добавлено свойство PDFExport.ColorProfile для использования в режиме совместимости с PDF/X-3
+ добавлена возможность экспорта изображений без потери качества в формат PDF
+ добавлено свойство PDFExport.ImageLossless
+ добавлено свойство IsScrolled в XAML экспорте
* устаревшие свойства: PDFExport.PdfA, PDFExport.PdfACompliance
- исправлена ошибка с тегами html в экспорте в Excel 2007
- исправлена ошибка с неверным форматом отрицательного числа в ячейке с CustomFormat в экспорте в Excel 2007 
- исправлена ошибка с line-height в HtmlObject при экспорте в HTML
- исправлена ошибка с пропуском последовательностей пробелов в текстовом объекте для Excel2007 и HTML экспортов
- исправлена ошибка обработки символов управления в экспорте Excel2007
- исправлена ошибка с шифрованием в PDF экспорте

  [WebReport]
+ добавлено функционирование гиперссылок на закладки в отчете (работает только с Layers = true)
+ добавлено функционирование гиперссылок на номер страницы (работает только с Layers = true)
+ добавлено функционирование обработчика клика по объекту (работает только с Layers = true)
+ добавлено функционирование детальных отчетов - гиперссылок на скрытую страницу отчета и на другой файл отчета (работает только с Layers = true)
+ добавлено новое свойство WebReport.ShowTabCloseButton (значение по умолчанию: false)
+ добавлено новое свойство WebReport.TabPosition (значение по умолчанию: TabPosition.InsideToolbar)
+ добавлен новый пример использования в Single Page Application \Demos\C#\Web\SPADemo 
+ добавлен новый пункт множества TabPosition.Hidden для скрытия вкладок с отчетами
* оптимизировано потребление памяти
* улучшено кеширование отчетов
- исправлена ошибка со скачиванием файлов экспортов в ОС Android
- исправлена ошибка в WebReport с CacheDelay в приложениях MVC
- исправлена ошибка с URLEncoded Cookies в Online Designer call-back
- исправлена ошибка с ID равным null в MVC
- исправлена ошибка с пропуском начальных пробелов в TextObject
- исправлена ошибка разбиения на страницы при печати из браузера

  [Extras]
+ добавлен коннектор SharePoint/"Office 365" \Extras\Connections\FastReport.SharePoint
* обновлены немецкие ресурсы


Версия 2016.3
---------------
  [Engine]
+ добавлены новые объекты PolyLineObject, PolygonObject
+ добавлены свойства Page.UnlimitedHeight, Page.UnlimitedWidth
* доработано рисование картинки под наклоном

  [Designer]
+ добавлен новый тулбар для редактирования PolyLineObject, PolygonObject
+ добавлен индикатор несохраненного отчёта в заголовке окна 
+ добавлены настройки неограниченной высоты и ширины в окно настроек страницы
+ добавлена возможность показа заставки во время загрузки дизайнера
+ добавлена возможность показа окна приветствия отображаемого после открытия дизайнера

  [Экспорты]
+ добавлена имитация Bold, Italic для шрифта "MS UI Gothic" и аналогичных в PDF экспорте
+ добавлен экспорт в JSON
+ добавлено свойство PDFExport.ShowPrintDialog для показа диалога печати после открытия документа PDF
+ добавлен экспорт объектов PolyLineObject, PolygonObject в PDF
+ добавлено свойство PDFExport.TextInCurves для включения экспорта текста в кривых без внедрения шрифтов в PDF документ
+ добавлена возможность отправлять несколько отчетов в виде вложений в экспорте электронной почты
+ добавлено свойство ToMultipleFiles в XAML экспорте
* улучшен экспорт в Excel 2007 с включеным свойством Seamless
* улучшена отрисовка штрих-пунктирных линий в PDF экспорте для корректной печати из Chrome
- исправлена ошибка с элементом <div> style(формат чисел) в послойном Html экспорте
- исправлена ошибка с картинками больше размера страницы в PDF экспорте
- исправлена ошибка с путями сохранения в экспортах: XAML, SVG, PostScript, PPML
- исправлена ошибка с тенями в HTML экспорте
- исправлена ошибка с отображением Underlines в HTML экспорте
- исправлена ошибка с вычислением хэша изображений в PDF экспорте
- исправлена ошибка с гиперссылками в демо версии в PDF экспорте
- исправлена ошибка с отсутствием заголовка в PostScript экспорте
- исправлена ошибка с распознованием шрифтов в PostScript экспорте

  [WebReport]
+ добавлены свойства Left, Top, Width, Height в CustomDrawEventArgs (могут быть использованы в WebReport.CustomDraw)
+ добавлен показ диалога печати при печати в PDF
+ добавлены свойства WebReport.DocxRowHeightIs, WebReport.PdfShowPrintDialog
+ добавлен метод WebReport.PrintInPdf(bool ShowPrintDialog) для установки показа окна печати при открытии PDF документа
* примеры использования WebReport обновлены и перемещены в папку \Demos\C#\Web
* обновлен встроенный jQuery до v1.12.3
- исправлена ошибка с событием CustomDraw внутри TableObject и Matrix
- исправлена ошибка с неверным MIME типом при печати в PDF
- исправлена ошибка с переключением локализаций в ASP.NET (не MVC)

  [Extras]
+ добавлен JsonConnectionEditor.cs в сборку FastReport.Json (\Extras\Connections\FastReport.Json)


Версия 2016.2
---------------
  [Ядро]
+ добавлено свойство Config.ReportSettings.ImageLocationRoot для установки локального корневого пути для PictureObject.ImageLocation
+ добавлена возможность загрузить карты из файлов OpenStreetMap (*.osm)
- исправлена ошибка с  возникновением исключения System.NullReferenceException после вызова метода ShowPrepared

  [Дизайнер]
+ добавлена возможность выделения и перетаскивания нескольких элементов из окна данных
- исправлена ошибка с перетаскиванием параметров в окне данных

  [Экспорты]
+ добавлена поддержка TextObject.TextOutline в PDF экспорте
+ добавлена поддержка LineHeight, ParagraphOffset в HTML экспорте
+ добавлена фильтрация html тегов в CSV экспорте
+ добавлена поддержка обрезки (TextObject.Clip) в PDF экспорте
- исправлена ошибка с пропуском пробела перед строкой с html-тегами
- исправлена ошибка отображения закладок в Acrobat Reader
- исправлена ошибка с упаковкой open type fonts в PDF экспорте
- исправлена ошибка с рамками в PDF экспорте

  [WebReport]
+ добавлено событие для отрисовки пользовательских объектов в Web или переопределения отрисовки стандартных объектов (WebReport.CustomDraw),
  работает только с включенным WebReport.Layer
+ добавлена поддержка послойного HTML в WebReport (WebReport.Layers) с лучшим WYSIWYG
+ добавлен интерфейс для передачи в Online Designer списка функций отчета
- исправлена ошибка с полями в контейнере WebReport
- исправлена ошибка с различными локализациями (WebReport.LocalizationFile)
- исправлена ошибка с popup в тулбаре
- исправлена ошибка с cookies приложения в Online Designer handlers
- исправлена ошибка с WebReport.XlsxWysiwyg

  [Service]	
+ добавлены новые методы в сервис FastReport.Service.dll (GetReportsListByPathXml, 
  GetReportsListXml, GetGearListXml, GetPreparedReportByID, GetReportXml, PutReport) 


Версия 2016.1
---------------
  [Engine]
+ добавлена окантовка текста с возможностью выбора цвета, толщины и стиля линии (свойство TextObject.TextOutline)
+ добавлено свойство TextObject.TextOutline.DrawBehind
- исправлена ошибка с ResetPageNumber с множественными вложенными GroupHeaderBand
- исправлена ошибка с обработкой выбора объекта в предварительном просмотре при включеном классическом виде бендов в дизайнере
- исправлена ошибка с возникновением исключения при попытке печати на отключенный принтер

  [Exports]
- исправлена ошибка с переносом строки в ODT экспорте
- исправлена ошибка с выходом за пределы массива в PDFExportPictures.cs

  [WebReport]
+ добавлено свойств WebReport.RefreshTimeout (время автоматического обновления отчета в секундах, 0 - автообновление отключено), 
  данное свойство может быть полезно при реализации функциональности Dashboard
* улучшено взаимодействие AJAX с сервером
- исправлена ошибка со скачиванием файлов из IE8 в Windows XP
- исправлена ошибка с одновременной работой нескольких объектов WebReport на странице
- исправлена ошибка с многострочным TextObject в диалогах

  [Demos]
- исправлена ошибка с x86 в vb Demos/VB.Net/Main/Form1.vb


Версия 2015.4
---------------
* новый инсталл
* теперь Online Report Designer стал отделным продуктом, все владельцы редакции Professional получили его бесплатно
* изменения в демонстрационном проекте Main и демонстрационных отчетах (\Demos\C#\Main)

  [Engine]
+ добавлена окантовка текста с возможностью задания толщины, цвета и стиля линии (свойство TextObject.TextOutline)
* увеличена скорость построения отчета
* уменьшено потребление памяти
* расширенная информация при возникновении исключения при вызове события из скрипта

  [Designer]
+ добавлена возможность конвертировать отчет DevExpress

  [Exports]
+ добавлен экспорт в FastReport Cloud
+ добавлен парсинг тега цвета текста в RTF экспорте
+ добавлено свойство Excel2007Export.Seamless для экспорта неразрывных таблиц
+ добавлены экспорты в PPML (Personalized Print Markup Language) и PostScript - (классы PPMLExport, PSExport)
+ добавлено свойство EmbedPictures(изображения, встроенные в файл) в HTML экспорт
* переделано сохранение в форматы Excel 2007, Word 2007, Power Point 2007, XPS
* оптимизировано потребление памяти в табличных экспортах
* увеличена скорость экспорта в Excel 2007
- исправлена ошибка с экспортом тени в табличных экспортах
- устранено дублирование кода в XAML, SVG, PPML, PostScript экспортах
- исправлена ошибка с URL ссылками в послойном экспорте HTML
- экспорт фигур(прямоугольник, прямоугольник с закруглёнными краями) в послойном экспорте HTML средствами CSS

  [WebReport]
+ добавлено свойство WebReport.XlsxSeamless для экспорта неразрывных таблиц в формат Excel 2007
+ добавлено свойство WebReport.EmbedPictures (внедрение картинок в HTML)
+ добавлено свойство WebReport.DesignerLocale (установка языка интерфейса для Online Report Designer)
- исправлена ошибка с отображением отчета с включенным свойством WebReport.SinglePage
- исправлена ошибка со значениями параметров по умолчанию
- исправлена ошибка с отображением картинок с включенным свойством WebReport.SinglePage 
- исправлена ошибка с многострочным TextBox
- исправлена ошибка с Azure cookies

  [Online Report Designer]
+ добавлен манифест html5 для оффлайновой работы (без iframe)
+ добавлен диалоговые контролы TextBox, RadioButton, Label, CheckBox, ButtonControl
+ добавлена поддержка диалоговых форм
+ добавлена поддержка двойного тапа для мобильных устройств
+ добавлена подсказка по горячим клавишам по нажатию на клавишу "h"
* оптимизирован парсер отчетов
* изменен алгоритм выделения нескольких объектов
- исправлена ошибка с префиксами подключений 
- исправлена ошибка с изменением имени системной переменной
- исправлена ошибка с изменением размера шрифта для TextObject
- исправлена ошибка с отображением Padding после загрузки
- исправлена ошибка с дублированием Dictionary в готовом отчете
- исправлена ошибка с копированием объектов
- исправлена ошибка, из за которой нельзя было двигать компонент через горячие клавиши
- исправлена ошибка с потерей connections в отчете при предварительном просмотре


Версия 2015.3
---------------
  [Engine]
- исправлена ошибка с изменением рабочего пути программы после вызова метода Report.Prepare
  [Designer]
+ добавлена возможность использовать FastReport.dll без FastReport.Bars.dll если дизайнер не вызывается
* ширина выпадающего списка в редакторе связей теперь соответствует ширине элементов
- исправлено неправильное отображение Японских символов в Ribbon тулбаре
- исправлена ошибка с потерей фокуса при вводе текста в редакторе кода когда активировано окно Events
- исправлена ошибка с удалением страницы после последовательности действий "CTRL+C -> CTRL+V -> DEL -> CLICK"
  [WebReport]
+ поддержка работы в среде Windows Azure
+ добавлены новые свойства WebReport.InlineRegistration, WebReport.ShowAfterPrepare
+ добавлено новое свойство WebReport.Debug
+ добавлена возможность сохранения отчета из On-line Designer с помощью POST запроса к call-back странице (если св-во WebReport.DesignerSavePath пустое)
+ добавлено свойство WebReport.CloudEnvironmet для включения совместимости с Azure 
+ добавлено событие WebReport.OnSaveDesignedReport для работы с сохраненным отчетом из On-line Designer (свойство FastReport.Web.SaveDesignedReportEventArgs.Stream)
+ добавлены методы прямого экспорта в файлы из браузера WebReport.ExportPdf(), WebReport.ExportOds() и т.д.
* оптимизация потребления памяти
* улучшены сообщения об ошибках
- исправлена ошибка с регистрацией скриптов 
- исправлена ошибка с пробелами в имени файла экспорта
- исправлена работа метода WebReport.RegisterData
- исправлена ошибка с передачей параметров
- исправлена ошибка с размером при height 100% в режиме дизайнера
- исправлена ошибка с поддержкой протокола HTTPS при обращении к call-back странице для сохранения отчета из On-line Designer
- исправлена ошибка с предварительным просмотром отчетов с диалогами из On-line Designer 
- исправлена ошибка доступа к файлам при отладочном запуске из Visual Studio под управлением IIS
- исправлена ошибка сериализации при работе в режиме Web Garden или Web Farm
  [On-line Report Designer]
+ добавлен индикатор для текстовых объектов, у которых размер содержимого больше габаритов
+ добавлено контекстное меню по правому клику мышью на некоторых объектах
+ добавлено свойство в конфигурационный файл 'default-tab-menu', которое указывает на вкладку меню по умолчанию
+ добавлена свойства в конфигурационный файл 'show-properties', 'show-events', 'show-rt', 'show-data', которые указывают, какие из панелей будут показаны при загрузке дизайнера
+ добавлена возможность изменять размер строки или колонки таблицы при помощи мыши
+ добавлено свойство в конфигурационный файл 'notifications', которое изменяет тип уведомлений ('default' или 'HTML5 Notifications'), либо вообще отключает их
+ добавлено удаление ячейки Totals в MatrixObject через контекстное меню
+ улучшена обработка Connections и DataSources
+ автоматическое присвоение бэнду DataSource при первом добавлении значения поля таблицы
+ добавлено контекстное меню в Report Tree для компонента или бэнда
+ добавлено контекстное меню при клике по бэнду
+ добавлено контекстное меню для MatrixObject
+ добавлены стили для MatrixObject
+ добавлена возможность открытия пустого отчета без загрузки шаблона по умолчанию в WebReport
+ добавлен редактор DataBand, GroupHeaderBand по двойному клику и пункт 'Edit' в контекстное меню
+ добавлен пункт 'Delete' в контекстное меню для бэндов
+ добавлен DatePicker для выбора дат в некоторых свойствах у объектов
+ в меню добавлена новая закладка Report и туда перенесены пункты Preview, Page, Save 
+ в меню в правом углу добавлена кнопка для вызова хелпера с подсказкой горячих клавиш	
+ добавлено popup окно для редактирования PictureObject
+ добавлена возможность включить прогресс индикатор, во время сохранения отчета в файле config-data (свойство show-saving-progress).
+ добавлено отображение в DataSource Relations
* если у колонки DataSource имеются вложенные колонки (или даже DataSources), то они отобразятся в Data панели
* окно с подтверждением удаления объектов и бэндов больше не отображается
* добавлено контекстное меню для компонентов
* в браузерах, которые не поддерживают input type color, используется плагин, реализующий функционал колорпикера
- исправлена ошибка с фильтрами бэндов и тегами html в текстовых объектах
- исправлена ошибка с отображением пустых иконок при загрузке on-line Designer
- исправлена ошибка json синтаксиса конфигурационного файла
- исправлена ошибка с добавлением GroupHeaderBand к DataBand и неверной позицией
- исправлена ошибка с сохранением padding текстовых объектов
- исправлена ошибка с сохранением карт
- исправлена ошибка с кавычками в редакторе скрипта
- исправлена ошибка с алиасами для источников данных, которые не применялись в выражениях


Версия 2015.2
---------------
  [Engine]
* обновлены японские ресурсы
- исправлена ошибка с открытием файлов frx/fpx с юникодной сигнатурой в начале файла
- исправлена ошибка с исключением CantFindObject при чтении отчета в WebMode
- исправлена ошибка с сохранением пустых файлов Excel 2007
- исправлена работа свойства RichTextQuality в PDF экспорте
  [Designer]
+ добавлен пункт "Предварительный просмотр" в меню "Файл" в Ribbon тулбаре
  [WebReport]
+ добавлен экспорт подготовленного отчета
* разбиение на страницы в экспорте в формат Excel 2007 из WebReport по умолчанию отключено
- исправлена ошибка с исключением CantFindObject при чтении отчета в WebMode
- исправлена ошибка с предварительным просмотром из дизайнера в разметке ASPX
- исправлена ошибка с позиционированием дизайнера
- исправлена ошибка с загрузкой отчета в дизайнер в разметке ASPX
  [Service]
+ added report exporting in Service
  [On-line Report Designer]
+ добавлена поддержка баркодов Aztec, Plessey, GS1-128/EAN-128
+ добавлена поддержка иерархических массивов с данными BusinessObjects
+ добавлены синонимы (Aliases) для источников данных
+ добавлена возможность копирования и вставки табличных компонент (TableObject, MatrixObject)
+ добавлена возможность активации/деактивации строк/колонок табличных компонентов
+ добавлен компонент MatrixObject
+ добавлен более широкий отступ между бендами
+ на мобильных устройствах ширина заголовка бэнда в уменьшена в 2 раза 
+ отмена создания компонента по клику на esc 
+ добавлена возможность в увеличить|уменьшить только отчет при помощи ctrl + mousewheel 
+ добавлено сохранение отчета при помощи клавиш ctrl + s 
+ добавлена подсветка углов выбранного компонента 
+ добавлены компоненты SimpleGauge, LinearGauge 
* изменена панель со свойствами и событиями 
* иконки приведены в соответствие десктоп версии 
* добавлена вкладка View для изменения настроек сетки и единиц измерения 
* изменена стилистику создания компонента 
* изменен алгоритм поиска компонентов на странице при выделении 
* улучшена работа с компонентом TableObject
* изменено оформление деревьев на вкладках report tree, data и в окне expression editor
* улучшен этап парсинга отчета с выводом сообщений в критических случаях
- исправлена ошибка, связанная с возможным дублированием имен компонентов/бендов
- исправлена ошибка с удалением ячейки табличного компонента, как обычного компонента
- исправлена ошибка с удалением дочерних бендов у последнего бенда на странице
- исправлена ошибка с изменением высоты бенда до 0
- исправлена ошибка, из за которой не сохранялись вложенные компоненты ячейки в итоговый .frx отчет 
- исправлены ошибки в TableObject, связанные с добавлением новых колонок и строк 
- исправлены ошибки в TableCell, в частности указание ячейки RowSpan и ColSpan 
- исправлена ошибка, проявлявшийся при задании высоты строки таблицы и ширины колонки таблицы 
- исправлена ошибка, при которой невалидные поля в свойствах не помечались 
- исправлена ошибка, связанная с показом уведомлений, когда меню свернуто 
- исправлена ошибка, связанная с невозможностью вытянуть потомков ячейки таблицы за левый край ячейки 
- исправлена ошибка, связанная с созданием новых компонентов на мобильных устройствах 
- исправлена ошибка при создании компонента на масштабированной странице 
- исправлена ошибка, когда создаваемый компонент кидался на ячейку таблицы и добавлялся на страницу, вместо ячейки таблицы 
- исправлена ошибка позиционирования LineObject в Firefox 


Версия 2015.1
---------------
+ добавлен on-line HTML5 дизайнер отчетов (beta) в WebReport - доступен в поставках: Trial и Professional 
  (\FastReport.Net\Source\FastReport.Web\WebReportDesigner)
+ добавлен новый Ribbon тулбар в дизайнере отчетов
+ добавлены новые стили интерфейса дизайнера: Office 2010 (Silver), Office 2010 (Blue), 
  Office 2010 (Black), Visual Studio 2010, Visual Studio 2012 (Light), Office 2013
+ добавлены возможности REST сервиса в библиотеку FastReport.Service.dll
+ добавлены баркоды Aztec, Plessey
+ добавлен баркод GS1-128 (ранее известный как UCC-128 или EAN-128). Поддерживаются только числовые значения.
+ добавлены новые свойства в WebReport: DesignReport, DesignScriptCode, DesignerPath, DesignerSavePath, 
  DesignerSaveCallBack, PrintInBrowser, SinglePage
+ добавлено свойство CSVExport.NoQuotes, отключающее кавычки при экспорте в CSV
* обновлены японские и греческие ресурсы
* обновлены демонстрационные примеры \Demos\C#\MvcRazor,\Demos\C#\WCFWebService,\Demos\C#\WCFWebClient 
- уменьшено потребление памяти в WebReport
- исправлена ошибка при экспорте в PDF/A
- исправлена ошибка в WebReport 'Access to the path \FastReport\ is denied'
- исправлена ошибка с утечкой памяти в PDF экспорте
- исправлена ошибка с отображением объекта Gauge в экспорте в формат Word 2007
- исправлена ошибка с кешированием в браузере результатов отчета в WebReport

Версия 2014.4
---------------
+ добавлено автосохранение в дизайнере, вы можете включить его и настроить период времени в Вид-Настройки-Сохранение 
+ добавлен редактор изображений в дизайнере, 
  который позволяет изменять размер, делать обрезку и менять цвет изображений на оттенки серого или ч/б
+ добавлен чекбокс "Enable Code Completion" в настройках свойств редактора кода
+ добавлена возможность выделения нескольких объектов при нажатой клавише CTRL в дизайнере
+ добавлена возможность пропорционального масштабирования при нажатой клавише SHIFT в дизайнере
+ добавлен выбор типа баркода в тулбаре дизайнера
+ добавлен редактор текста баркода
+ добавлена поддержка кодировок Windows-1251, cp866 в объекте QR-code
+ добавлена поддержка прозрачности картинок в PDF экспорте
+ добавлено соответствие требованиям PDF/A-2a,b и PDF/A-3a,b в PDF экспорте
+ добавлено новое свойство PDFExport.PdfACompliance 
  (может быть выбрано из PdfAStandard.PdfA_2a, PdfAStandard.PdfA_2b, PdfAStandard.PdfA_3a, PdfAStandard.PdfA_3b)
+ добавлены опции для выбора стандарта PDF/A, качества Jpeg-сжатия, начального масштаба в диалоге PDF экспорта
+ добавлена поддержка диалоговых объектов ListBoxControl, CheckedListBoxControl в WebReport
* увеличена скорость работы PDF экспорта с прозрачными изображениями
- исправлена ошибка в дизайнере с сохранением отчета из закладки редактора кода 
  (кнопка сохранения оставалась неактивной после изменений в коде)
- исправлена ошибка с разрывом бэндов
- исправлена ошибка с экспортом одной страницы в PDF

Версия 2014.3
---------------
+ добавлен редактор QR-кодов в дизайнере
+ добавлен конвертер из шаблона отчета List & Label
+ добавлен пример проекта для среды WebMatrix (\Demos\C#\WebMatrix)
+ добавлен вертикальный линейный индикатор 
+ добавлен простой индикатор
+ добавлен вертикальный простой индикатор
+ добавлены новые свойства AloowExpression, Brackets в объект Barcode
+ добавлено новое свойство Inverted для линейного индикатора
+ расширены возможности настройки шкалы простого индикатора
+ добавлено свойство DefaultZoom в PDF экспорт
+ добавлено свойство DefaultPage в PDF экспорт
+ добавлен экспорт в CSV в WebReport
+ добавлена обработка событий Load, FormClosing и FormClosed для DialogPage в WebReport
+ добавлен объект MonthCalendar в WebReport
* обновлены французские, немецкие, японские ресурсы
- исправлена ошибка масштабирования линейного индикатора
- исправлена ошибка с пробелами в имени файла экспорта в WebReport
- исправлена ошибка с размерами метафайла в RTF экспорте
- исправлена ошибка с межстрочным интервалом в RTF экспорте
- исправлена ошибка с HTML-тегами в RTF экспорте
- исправлена ошибка с ландшафтной ориентацией страниц в экспорте в Word 2007 (docx)
- исправлена ошибка с выделением текста (Ctrl+A) в инспекторе объектов в дизайнере
- исправлена ошибка с обновлением объекта DateTimePicker в WebReport

Версия 2014.2
---------------
+ добавлен коннектор Google BigQuery \Extras\Connections\FastReport.GoogleBigQuery
+ добавлен пример работы с Google BigQuery \Demos\C#\GoogleBigQuery 
+ добавлена возможность сохранения готового отчета в облако Box
+ добавлена обработка line-spacing в RTF и DOCX экспортах
* увеличена скорость доступа к базам данных (в ряде случаев до 6 раз)
* обновлены немецкие и японские ресурсы
* изменено отображение названий языков в диалоговом окне выбора языка интерфейса
- исправлена ошибка с отображением шрифтов в SVG экспорте
- исправлена ошибка с отображением текста окна ProgressBar по умолчанию
- исправлена ошибка с функцией AVG в редакторе карт
- исправлена ошибка в упаковщике шрифтов PDF экспорта, приводящая к некорректному экспорту некоторых шрифтов
- исправлена ошибка с появлением артефактных линий в RoundRectangle при большом значении Curve
- исправлена ошибка с ParagraphOffset в экспорте RTF
- исправлена ошибка с отображением подсказок в тулбаре WebReport

Версия 2014.1
---------------
+ добавлена совместимость с Fips Algorithm Policy (ограничения: шифрование PDF экспорта, шифрование отчета)
+ добавлена поддержка PDF/A в PDF экспорте
+ добавлен экспорт в формат SVG
+ добавлена поддержка html тегов <B>, <I>, and <U> в экспорте в RTF документы.
+ добавлена возможность локализации в WebReport (свойство WebReport.LocalizationFile)
+ добавлена возможность установки пользовательских значков кнопок в тулбаре WebReport
+ добавлен новый пример локализации и кастомизации Webreport (Demos\C#\MvcCustomization\)
* добавлена печать по умолчанию на кнопке в тулбаре WebReport, если свойство WebReport.PrintInPdf равно false
- исправлена ошибка с параграфами в экспортах RTF и Word2007
- исправлена ошибка с добавлением индикатора
- исправлена ошибка с bookmarks в PDF экспорте
- исправлена ошибка c лишней пустой страницей в табличном экспорте в MS Word 2007
- исправлена ошибка с границами в XAML экспорте
- исправлена ошибка с отображением контрола ASP.NET WebReport на странице в Vsual Studio
- исправлена ошибка с показом невидимых диалогов в WebReport
- исправлен межстрочный интервал в послойном экспорте в Word 2007
- исправлена ошибка при вводе некорректного адреса сервера при сохранении на FTP сервер

Версия 2013.4
---------------
+ добавлен просмотр нескольких независимых отчетов в WebReport
+ добавлен экспорт в формат XAML
+ добавлен линейный индикатор 
+ добавлен пример отчета с линейным индикатором (Gauge.frx)
* показ имени бэнда в редакторе итогов
- исправлена ошибка в PDF экспорте с записью очень больших картинок
- исправлена ошибка с отображением контрола ASP.NET WebReport на странице в Vsual Studio
- исправлена ошибка с PrintOn.FirstPage | PrintOn.LastPage
- исправлена ошибка с количеством цифер после запятой в стилях чисел в экспортах
- исправлена ошибка с невидимыми объектами (за границами страницы) в табличных экспортах
- исправлена ошибка с межстрочным интервалом в послойном экспорте в Word2007

Версия 2013.3
---------------
+ добавлен новый объект - "Искрографик" (SparklineObject)
+ добавлена возможность сохранения готового отчета на FTP
+ добавлена библиотека Windows Communication Foundation (WCF) Service Library FastReport.Service.dll
+ добавлен пример создания службы Windows \Demos\C#\WCFWindowsService с использованием WCF Service Library
+ добавлен пример создания веб-службы WCF \Demos\C#\WCFWebService  
+ добавлен пример создания клиента службы WCF \Demos\C#\WCFClient 
+ добавлен пример создания веб-клиента службы WCF \Demos\C#\WCFWebClient
+ добавлены методы WebReportGlobals.ScriptsWOjQuery() и WebReportGlobals.StylesWOjQuery() 
  для использования WebReport без встроенной библиотеки jQuery (применимо в MVC Razor)
+ добавлено свойство WebReport.ExternalJquery (default: false) для отключения использования встроенной библиотеки jQuery (применимо в ASPX)
+ добавлена функция WeekOfYear
+ добавлена локализация Slovenian
* report.RegisterData(ds) заменяет существующие datasources в отчете
- исправлена ошибка с повторным экспортом в PDF из кода
- исправлена ошибка в PDF экспорте с невозможностью распечатки документа из Acrobat Reader при наличии гиперссылок
- исправлена ошибка в экспорте в Excel 2007 со стилями для могостраничных шаблонов отчетов
- исправлена ошибка в экспорте в Excel 2007 с пустым названием страницы
- исправлена ошибка в PDF экспорте с двойными рамками
- исправлена ошибка в картах с правами доступа к файлу

Версия 2013.2
---------------
+ добавлена поддержка ASP.NET MVC framework (ASPX, Razor) в WebReport
+ добавлены новые примеры использования WebReport в MVC - \Demos\C#\MvcDemo, \Demos\C#\MvcRazor
+ добавлено сохранение в облако Google Drive 
+ добавлена греческая локализация
* ВНИМАНИЕ! изменено расширение WebReport handler (было FastReport.Export.aspx, стало FastReport.Export.axd), 
  просим исправить существующие файлы web.config
- исправлена ошибка с Application Key и Secret в экспорте Dropbox
- исправлена ошибка с NullReferenceException при экпорте в Dropbox
- исправлена ошибка c кодировкой при импорте файла dDase для карты в экспорте DBX
- исправлена ошибка с числовыми форматами Excel
- исправлена ошибка с неправильным форматом после оптимизации матрицы в экспорте Excel 2007 
- исправлена ошибка с прозрачностью шрифитов в пустых ячейках в экспорте Excel 2007
- исправлена ошибка с дублированием склеенных ячеек в экспорте Excel 2007 
- исправлена ошибка с внедрением моноширинных шрифтов в экспортах в PDF и XPS
- исправлена ошибка стилей в WebReport
- исправлена ошибка с WebReport.RepotDone
- исправлена ошибка с Master Pages в WebReport
- исправлена ошибка при печати легенды диаграммы
- исправлена ошибка в PictureObject


Версия 2013.1
---------------
+ добавлена поддержка диалогов в WebReport (некоторые объекты и возможности в разработке)
+ добавлен объект "Карта"
+ добавлена возможность сохранения готового отчета в DropBox
+ добавлена возможность сохранения готового отчета в SkyDrive
+ добавлен новый тулбар в WebReport
+ добавлена поддержка AJAX в WebReport
+ добавлен выбор PrintOn.SinglePage в свойство PrintOn (нужен двойной проход)
+ добавлено свойство AdjustSpannedCellsWidth в объекты "Матрица" и "Таблица"
+ добавлено свойство Wysiwyg в экспорт в Word 2007
+ добавлена поддержка якорей в PDF экспорте
+ добавлена локализация Armenian
+ добавлено свойство Label у серии диаграммы
- исправлена ошибка при сохранении отчета в .cs/.vb файл
- исправлена ошибка drag&drop в редакторе кода
- исправлена ошибка в экспорте TXT
- исправлена ошибка в экспорте в Word 2007 в послойном режиме
- исправлена ошибка с числовым форматом в экспортах в Excel
- исправлена ошибка при сохранении отчета в файл VB.Net


Версия 1.9
---------------
* подтверждена совместимость с Visual Studio 2012
+ добавлен штрих-код QR Code
+ добавлено свойство Exportable во все объекты отчета
+ добавлена поддержка UNC путей в файловом хранилище WebReport (web.config)
+ добавлено событие Config.PreviewSettings.PreviewOpened
+ добавлено свойство BackPage у страницы отчета
+ добавлено свойство WebReport.XmlExcelDataOnly
* улучшен WebReport
* увеличена скорость печати объекта "Таблица"
* улучшена печать данных в заголовках/подвалах
- исправлена ошибка с вложенным отчетом и колонками датабэнда
- исправлена ошибка с вложенным отчетом и разрываемым бэндом
- исправлена ошибка с несколькими закладками в окне просмотра
- исправлена ошибка с Config.DesignerSettings.ApplicationConnection
- исправлена ошибка с картинками в PDF экспорте
- исправлена ошибка с рамкой объекта "Таблица" при экспорте в некоторые форматы
- исправлена ошибка в WebReport с несколькими экземплярами на одной странице
- исправлена ошибка в WebReport с очисткой внутреннего хранилища
- исправлена ошибка с фильтрацией данных с помощью контрола NumericUpDown


Версия 1.8
---------------
+ добавлена поддержка Web Farms и Web Gardens в WebReport (пример \Demos\C#\WebFarm\Web.Config)
+ добавлено свойство HoverStyle во все объекты отчета
+ добавлено свойство WebReport.CachePriority
* улучшен WebReport путем использования ControlState вместо ViewState, улучшена стабильность
- исправлена ошибка при открытии RDL-файла из списка недавних файлов
- исправлена ошибка с пустым вложенным отчетом
- исправлена ошибка в плагине импорта Crystal Reports (некорректное конвертирование типа некоторых секций)
- исправлена ошибка в плагине импорта Crystal Reports (некорректное конвертирование даты создания отчета)
- исправлена ошибка в плагине импорта Crystal Reports (некорректное конвертирование свойства PaperOrientation)
- исправлена ошибка в плагине импорта Crystal Reports (некорректное конвертирование размера бумаги форматов B4 и B5)
- исправлена ошибка в плагине импорта Crystal Reports (некорректное конвертирование групп)
- исправлена ошибка с вложенным отчетом и опцией KeepTogether
- исправлена ошибка с параметрами отчета и undo/redo
- исправлена ошибка с линиями нулевой толщины и стилем Dash или Dot в PDF экспорте
- исправлена ошибка с двойным проходом и бизнес-объектами
- исправлена ошибка с печатью/экспортом интерактивных отчетов
- исправлена ошибка при вызове дизайнера компонента WebReport
- исправлены отступы при экспорте в RTF/Word2007
- исправлена ошибка в экспорте PDF (картинки и шифрация)
- исправлена ошибка с картинками при редактировании готового отчета
- исправлен экспорт числового формата в Excel


Версия 1.7
---------------
+ добавлено событие Config.DesignerSettings.PageAdded
+ добавлено свойство Config.PreviewSettings.AllowPrintToFile
+ добавлено свойство Report.MaxPages
+ добавлен плагин импорта из Crystal Reports
+ добавлено свойство MatrixObject.KeepCellsSideBySide
+ добавлено оглавление (outline) в PDF экспорте
+ добавлено свойство TableObject.ManualBuildAutoSpans
+ добавлены свойства TableRow.KeepRows, TableColumn.KeepColumns
+ добавлена возможность скрывать фильтры экспортов и объекты отчета: RegisteredObjects.FindObject(typeof(PDFExport)).Enabled = false
* улучшена работа файлового кеша отчета
* улучшена загрузка файлов .fpx
* CheckBoxObject доступен в версии FR.Net Basic
- исправлена ошибка с отображением текста в WebReport если TextObject.WordWrap = false; 
- исправлена утечка памяти при экспорте в PDF с опцией "Встроить шрифты"
- исправлена ошибка с разрывом бэнда
- исправлена ошибка с информационными полями в зашифрованном PDF файле
- исправлена ошибка с рамками и заливкой страницы в PDF экспорте
- исправлена ошибка в RichObject
- исправлена ошибка в окне предварительного просмотра
- исправлена ошибка при сохранении отчета в виде класса
- исправлена ошибка с некоторыми типами картинок
- исправлена ошибка с разрывом текста
- исправлена ошибка с обработчиками событий
- исправлена ошибка с определением высоты текста в RichObject
- исправлена ошибка в PDF экспорте (пропадали картинки при просмотре в MAC OS или iOS)
- исправлена ошибка с выравниванием по сетке
- исправлена ошибка с разрывом бэнда и outline
- исправлена ошибка при экспорте в метафайл
- исправлена ошибка с унарным минусом и итогами
- исправлена ошибка с водяным знаком


Версия 1.6
---------------
+ добавлена возможность сохранения шаблона в формате RDL (Report Definition Language)
+ добавлено свойство Report.InitialPageNumber
+ добавлены локализации Romanian, Hungarian
+ добавлено свойство TextObject.ParagraphOffset
+ добавлено свойство PreviewControl.UseBackColor
+ добавлена функция IsNull для проверки значения поля БД на null
+ добавлена локализация Thai
+ добавлен импорт свойства WritingMode при импорте RDL-отчетов
+ добавлено сохранение свойства TextObject.Angle при сохранении отчетов в формате RDL
+ добавлено кодирование символа FNC1 в штрихкод Datamatrix (используйте последовательность &1;)
+ добавлены экспорты в Open Document Text, XPS, DBF в WebReport
* добавлена возможность замены встроенного построителя запросов
* изменен механизм работы экспортов и печати в WebReport, теперь используется handler в файл web.config
- исправлена ошибка в режиме печати "масштабирование"
- исправлена ошибка в объекте RichObject (св-во CanShrink не работает с пустым текстом)
- исправлена ошибка при разрыве объекта "Текст"
- исправлена ошибка в свойстве TextObject.TabWidth
- исправлена ошибка при сохранении готового отчета с флагом UseFileCache
- исправлены ошибки RichObject в многопоточном режиме
- исправлена ошибка при открытии некоторых сохраненных в RDL отчетов в Report Builder
- исправлена ошибка в мастере группировки
- исправлена ошибка с фильтром в ChartObject при сохранении отчета в класс C#/VB.Net
- исправлена ошибка при конвертировании булевых выражений в RDL импорте
- исправлена ошибка с внутренним манифестом в ODF экспорте

Версия 1.5
---------------
+ добавлен импорт из формата RDL (Report Definition Language)
+ добавлен экспорт в формат XPS
+ добавлен экспорт в формат Word 2007 (docx)
+ добавлено свойство DataBand.ResetPageNumber
+ добавлены свойства PDFExport.JpegQuality и PDFExport.RichTextQuality (значения по умолчанию равны 90)
+ добавлена локализация Slovak
+ добавлена поддержка пользовательских функций в итогах матрицы
+ добавлено вычисление процентов в объекте "Матрица"
+ добавлена опция TotalsFirst (итоги в начале) для итогов матрицы
+ добавлено свойство HTMLExport.Layers и пункт на диалоге HTML экспорта - включают режим построения послойного HTML файла
+ добавлено событие Config.ReportSettings.ReportPrinted
+ добавлено событие DataLoaded во все диалоговые контролы, поддерживающие фильтрацию данных
+ добавлена печать из браузера в WebReport
+ добавлены свойства WebReport.PrintInPdf (включить для показа PDF при печати или отключить для печати из браузера)
+ добавлены свойства WebReport.PrintWindowWidth, WebReport.PrintWindowHeight
+ добавлены свойства WebReport.ShowWord2007Export, WebReport.DocxMatrixBased
* добавлено свойство DbfExport.FieldNames вместо FieldNamesFileName, LoadFieldNamesFromFile
* улучшена работа TextObject.Duplicates
- исправлена ошибка в объекте "Текст" с html тэгами и стилем "подчеркнутый"
- исправлена ошибка с опцией "Не отрывать от данных" и многоколоночным бэндом "Данные"
- исправлена ошибка с размером бумаги
- исправлена ошибка при отображении нескольких объектов "Таблица" на одном бэнде
- исправлена ошибка со структурой отчета (preview outline)
- исправлена ошибка в RTF экспорте с одинаковыми картинками
- исправлена ошибка с CheckedListBoxControl и каскадной фильтрацией
- исправлена ошибка с subreport и многоколоночным бэндом
- исправлена ошибка с FirstTabOffset
- исправлена ошибка со статическими параметрами запроса и master-detail отчетом
- исправлена ошибка в экспорте в PowerPoint
- исправлена ошибка EvenStyle в объекте "Матрица"


Версия 1.4
---------------
+ добавлена поддержка Visual Studio 2010
+ добавлена поддержка частичного внедрения шрифтов в PDF экспорте
+ добавлено подключение к SQL CE
+ добавлена системная переменная HierachyRow#, возвращающая номер строки вида "1.2.1" в иерархическом отчете
+ добавлена поддержка схемы таблицы в коннекторы OleDB, ODBC
+ добавлена функция NumToWordsEs (число прописью на испанском)
+ добавлена локализация Dutch
+ добавлена локализация на украинский
+ добавлено свойство Config.ReportSettings.DefaultPaperSize
+ добавлено свойство HTMLExport.Print - разрешает показ диалога печати в браузере при открытии html документа в одностраничном режиме
+ добавлено свойство HTMLExport.PageBreaks - разрешает разрывы между страницами при печати документа из браузера в одностраничном режиме
+ добавлено свойство ForceLoadData у источника данных
+ добавлено свойство band.FirstRowStartsNewPage
+ добавлено свойство Parameter.Description
+ добавлено свойство Config.TempFolder
+ добавлено свойство report.ReportInfo.PreviewPictureRatio
+ добавлено свойство DataBand.PrintIfDatasourceEmpty
+ добавлено свойство ChildBand.PrintIfDatabandEmpty
+ добавлен флаг Config.DesignerSettings.Restrictions.DontCreateData для запрета добавления новых источников данных
- исправлена ошибка с Row# и StartNewPage
- исправлена ошибка с пользовательскими функциями типа Nullable
- исправлена ошибка с одновременной установкой свойств CanBreak и StartNewPage у бэнда
- исправлена ошибка с пропуском стилей оформления в HTML при экспорте большого количества страниц в одностраничном режиме
- исправлена ошибка с регистрацией плагинов
- исправлена ошибка в диалоговых контролах, прикрепленных к вычисляемому полю
- исправлена ошибка в построителе запросов (неверный тип join)
- исправлена ошибка с порядком контролов в диалоговых формах
- исправлена ошибка с Dock != None и CanGrow, CanShrink
- исправлена ошибка в экспорте HTML
- исправлена ошибка с сохранением имени принтера в файле отчета
- исправлена ошибка в объекте "Диаграмма" (не работает метод ClearValues)
- исправлена ошибка в мастере подключения к данным
- исправлена ошибка в итогах, если опция "Преобразовать null значения" отключена
- исправлена ошибка с записью отчета в виде класса VB
- исправлено "дерево отчета" (outline) в иерархическом отчете
- исправлена ошибка в объекте "Диаграмма" (при попытке сгруппировать несортированные данные по месяцам)
- исправлена ошибка в диалоге "Мастер подключения к данным" в Windows Vista
- исправлена ошибка с внедрением TTC шрифтов в PDF экспорте
- исправлена ошибка при экспорте объекта TableObject с невидимыми строками
* улучшения в диалоге "Мастер подключения" (чтение списка таблиц выполняется значительно быстрее)
* команда дизайнера DesignerControl.cmdData заменена на cmdAddData и cmdChooseData
* уменьшен размер создаваемого файла в HTML экспорте
* улучшена производительность при работе с бизнес-объектами с глубоким уровнем вложенности
* сортировка списка таблиц в "Мастере подключения к данным" по умолчанию, убрана кнопка "Сортировать"
* небольшие улучшения в окне "Данные" (возможность двигать параметр отчета вверх/вниз с помощью Ctrl+Up/Down)
* программа инсталляции теперь автоматически добавляет все dll в GAC
* сборка FastReport.dll разделена на части - FastReport.dll, FastReport.Web.dll


Версия 1.3
---------------
+ добавлен экспорт в монохромный TIFF
+ добавлен экспорт в Excel 2007
+ добавлен экспорт в PowerPoint 2007
+ добавлен экспорт в MHT (веб-архив)
+ добавлен экспорт в DBF 
+ добавлено подключение к ODBC
+ добавлено подключение к Oracle ODP.NET
+ добавлена печать имени копии (см. отчет "Features/Print Copy Names")
+ добавлена встроенная поддержка каскадной фильтрации (св-во DetailControl). См. отчет "Dialogs/Cascaded Data Filtering"
+ добавлены флаги "применить" к элементам стиля
+ добавлены пункты в контекстное меню бэнда для быстрого создания дочернего бэнда и детального бэнда "Данные"
+ добавлено свойство TextObject.NullValue (заменяет null значение на указанное в свойстве)
+ добавлено свойство TextObject.ProcessAt (позволяет печатать итог в заголовке)
+ добавлено свойство ImageExport.MonochromeTiffCompression
+ добавлены свойства HTMLExport.WidthUnits, HTMLExport.HeightUnits (позволяют выбирать между Pixel и Percent)
+ добавлен режим Message-HTML (MHT, MHTML, веб-архив) в HTML экспорт (свойство HTMLExport.Format)
+ добавлено событие Config.DesignerSettings.FilterConnectionTables
+ добавлено событие DataSourceBase.Load для заполнения источника данных в коде
+ добавлена локализация Croatian
+ добавлена локализация Persian
+ добавлены новые примеры в папке Demos\VB.Net
+ добавлен демо-отчет "Script/Sort Group By Total"
* улучшена работа механизма "Не отрывать от данных"
- исправлена ошибка в объектах "Матрица" и "Таблица" (не работает св-во Visible)
- исправлена ошибка в подключении MS SQL (невозможно использовать таблицы из схем, отличных от dbo.*)
- исправлена ошибка в режиме Medium Trust
- исправлена ошибка в бизнес-объектах (совпадение имен у источников данных)
- исправлена ошибка в диалоговых формах (переключение на страницу диалога может вызвать исключение)
- исправлена ошибка в построителе запросов
- исправлена ошибка с OutlineExpression и RepeatOnEveryPage
- исправлена ошибка с KeepChild
- исправлена ошибка с экспортом штрихкодов
- исправлена ошибка в диалоговых контролах (Enabled & data filtering)
- исправлена ошибка с RepeatOnEveryPage и дочерним бэндом
- исправлена ошибка в объектах "Таблица" и "Матрица" (бесконечный цикл, если колонка не помещается на странице)
- исправлена ошибка в PDF экспорте (структура файла)
- исправлена ошибка в дизайнере при попытке копирования итога
- исправлена ошибка - исключение при закрытии дизайнера
- исправлена ошибка с отключением навигатора в HTML экспорте
- исправлена ошибка с указанием размеров WebReport в процентах
- исправлена ошибка в PDF экспорте (подстановка цифр в арабском)
- исправлена ошибка сортировки по вычисляемому полю
- исправлена ошибка в PDF экспорте (экспорт бэнда с нулевой высотой и установленной заливкой)
- исправлена ошибка в редакторе текста/выражения (drag&drop из дерева данных)
- исправлена ошибка в экспорте Excel 2007
- исправлена ошибка в диалоге печати (свойства принтера)
- исправлена ошибка с Outline, когда несколько отчетов объединяется в один
- исправлен поиск в окне просмотра
- исправлена ошибка в группах, когда нет данных для отображения


Версия 1.2
---------------
+ добавлены функции в окно "Данные"
+ добавлены новые объекты - CellularTextObject, ZipCodeObject
+ добавлены настройки email в отчет (см. меню Отчет|Свойства, закладка "Email")
+ добавлен экспорт в многостраничный файл TIFF
+ добавлено шифрование RC4 128-bit в PDF экспорте
+ добавлен флаг "Видимый" в редактор условного выделения. Теперь можно скрывать объект по условию
+ добавлены свойства AutoShrink, AutoShrinkMinSize у объекта "Текст"
+ добавлено свойство DataBand.RowCount
+ добавлено событие ReportPage.ManualBuild
+ добавлено свойство PictureObject.Angle
+ добавлено событие AfterData у всех объектов отчета
+ добавлено свойство CommandTimeout во все подключения
+ добавлен экспорт водяных знаков в HTML формат
+ добавлена возможность экспорта разлинованного TextObject (Underlines = true) в PDF формат
+ добавлены локализации Swedish, Chinese (Traditional), Czech, Turkish, Spanish
+ добавлены новые демо-отчеты в категории "Report Objects"
+ добавлены новые примеры в папке Demos
* ВОЗМОЖНАЯ "поломка кода"! изменения в движке бизнес-объектов. См. подробности на форуме:
http://fast-report.com/ru/forum/index.php?showtopic=6522
* улучшена производительность (загрузка и запуск отчетов, содержащих большое количество объектов)
* при печати иерархии теперь можно использовать свойство Anchor у объектов бэнда
* изменено расширение результирующего файла в Excel(XML) экспорте с *.xls на *.xml
* изменения в экспорте Excel(XML) - поддержка экспорта числовых значений
* изменения в объекте "Матрица"
* улучшения в иерархических отчетах (заголовки/подвалы, итоги)
- исправлена ошибка с языком отчета VB.Net
- исправлена ошибка в Viewer.exe (исключение, если окно слишком маленькое)
- исправлена ошибка при выборе объекта Report в окне "Дерево отчета" в VS design-mode
- исправлена ошибка при использовании WebReport и MasterPage
- исправлена ошибка с отображением RTL в HTML экспорте и WebReport
- исправлена ошибка с отображением RTL в RichText(rtf) экспорте
- исправлена ошибка в MS Chart (толщина рамки при печати)
- исправлена ошибка с диалогом поиска текста в превью
- исправлена ошибка с типом Nullable<T>
- исправлена ошибка в экспорте PDF (при экспорте сложной заливки)
- исправлена ошибка с экспортом различных стилей рамок в форматы XML и RichText
- исправлена ошибка при редактировании готового отчета
- исправлена ошибка при печати объекта CellularTextObject
- исправлена ошибка с диалоговой формой
- исправлена ошибка с Entity Framework в ASP.NET
- исправлена ошибка в диалоге настройки страницы в окне просмотра
- исправлена ошибка с разверткой двух объектов "Матрица", расположенных рядом
- исправлена ошибка в мастере этикеток
- исправлена ошибка при отправке email через MAPI


Версия 1.1
---------------
+ добавлены новые стили интерфейса - Office2007Blue, Office2007Silver, Office2007Black, VistaGlass. 
Выбрать стиль можно в меню "Вид/Настройки..." дизайнера, или с помощью компонента EnvironmentSettings
(св-во UIStyle)
+ добавлен экспорт в CSV
+ добавлен экспорт в Text/Dot-matrix
+ добавлены приложения Designer.exe и Viewer.exe
+ добавлен элемент управления DesignerControl
+ добавлена команда "Копировать формат" на панель инструментов "Стандартная"
+ добавлены новые системные переменные - "TotalPage#" и "Page#"
+ добавлена поддержка источника данных BindingSource
+ добавлено свойство "RTFExport.ImageFormat"
+ добавлены свойства HideIfNoData, NoDataText в BarcodeObject
+ добавлен новый демо-проект - MdiDesigner
+ добавлен демо-отчет "Table/Fit Dynamic Table To Page"
+ добавлен демо-отчет "Dialogs/Cascaded Data Filtering"
+ добавлен демо-отчет "Interactive Reports/Interactive Matrix With Chart"
+ добавлен демо-отчет "Dialogs/Labels With Dialog"
+ добавлена локализация Chinese (simplified)
+ добавлена локализация Arabic
+ добавлен экспорт прозрачных цветов и картинок (alpha blending) в PDF формат
+ добавлен экспорт линий, стрелок, прямоугольников теней в PDF формат
+ добавлен экспорт водяных знаков в PDF формат
+ добавлен экспорт паттернов линий в PDF формат
+ добавлен экспорт горизонтальных и вертикальных линий, прямоугольников, теней в Excel(xml), 
RichText, OpenOffice и HTML форматы
* улучшена поддержка Unicode в PDF экспорте
* MSChart объект перемещен в главный модуль FastReport.dll, больше не нужно подключать его как плагин
* библиотека FastReport.Dock заменена на FastReport.Bars
- исправлена ошибка в дизайнере при запуске в среде Vista 64-bit
- исправлена ошибка с вложенным отчетом и разрываемым бэндом
- исправлена ошибка в объекте Matrix (разрыв объединенной ячейки)
- исправлена ошибка при создании обработчика события, если выбрано несколько объектов
- исправлена ошибка в экспорте в PDF (правая граница объекта TableObject)
- исправлена ошибка с потерей фокуса при закрытии окна просмотра
- исправлена ошибка с выравниванием текста по ширине
- исправлена ошибка в окне "Данные" (если был зарегистрирован некорректный объект DataRelation)
- исправлена ошибка в VS IDE (дизайнер закрывается при закрытии окна просмотра)
- исправлена ошибка с буфером обмена при редактировании объекта TextObject на месте
- исправлена ошибка с MS SQL параметром типа Guid
- исправлена ошибка с обработкой бизнес-объектов
- исправлена ошибка со свойством PrintOnParent вложенного отчета
- исправлена ошибка с одновременной печатью обычной и динамической таблицы на одном бэнде
- исправлена ошибка с параметрами отчета
- исправлена ошибка с параметрами SQL
- исправлена ошибка с совпадением имен объектов TableObject и TableDataSource
- исправлена ошибка со свойством "Visible" у TableRow, TableColumn
- исправлена ошибка в функции "Count" объекта "Матрица"
- исправлена ошибка с разрывом объекта "Таблица"
- исправлена ошибка со связями и пустыми колонками данных
- исправлена ошибка с вращением текста в экспортах Excel(xml), RichText, OpenOffice, HTML, PDF
- исправлена ошибка с вложенным отчетом и свойством "RepeatOnEveryPage"
- исправлена ошибка при вставке объектов типа "generic" из окна "Данные" в скрипт
- исправлена запись свойства "Script" в файл .frx
- исправлены задержки в работе дизайнера, если выбрано много объектов
- исправлена ошибка с PictureObject.Tile
- исправлена ошибка экспорта разрывов страниц и полей в XML формат
- исправлена ошибка экспорта разных линий окантовки в Excel(xml), RichText, OpenOffice, HTML и PDF форматы
- исправлена ошибка с подчеркнутым и перечеркнутым текстом в PDF экспорте
- исправлена ошибка с окантовками TableObject в PDF экспорте
- исправлена ошибка с заголовком документа в PDF экспорте


Версия 1.0.163
---------------
Релиз
